SystemOrganization addCategory: #'Smallapack-Matrix'!
SystemOrganization addCategory: #'Smallapack-Matrix-testing'!

!ExternalDoubleArray methodsFor: '*Smallapack-Matrix' stamp: 'nice 5/20/2006 00:59'!
asLapackMatrixNrow: nr ncol: nc 
	^LapackDGEMatrix 
		fromSequence: self copy
		nrow: nr
		ncol: nc! !

!Float methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/23/2006 23:38'!
asDoubleComplex
	^self i: 0.0! !

!Float methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/23/2006 23:38'!
asFloatComplex
	^self i: 0.0! !

!Float methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 2/16/2006 04:01'!
coercing: aMatrix do: aBlock 
	^aMatrix coercingFromRealNumber: self do: aBlock! !

!Number methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/23/2006 23:39'!
asDoubleComplex
	^self asFloat asDoubleComplex! !

!Number methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/23/2006 23:39'!
asFloatComplex
	^self asFloat asFloatComplex! !

!Number methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/20/2006 03:00'!
asLapackMatrix 
	^LapackDGEMatrix 
		fromSequence: (ExternalDoubleArray with: self asFloat)
		nrow: 1
		ncol: 1! !

!Number methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 2/16/2006 04:01'!
coercing: aMatrix do: aBlock 
	^aMatrix coercingFromNumber: self do: aBlock! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:01'!
concatColumnsFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat concatColumnsWithLapackMatrix: (mat class 
						nrow: 1
						ncol: 1
						withAll: self)]! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:02'!
concatRowsFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat concatRowsWithLapackMatrix: (mat class 
						nrow: 1
						ncol: 1
						withAll: self)]! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:02'!
differenceFromLapackMatrix: aMatrix 
	"No such function available in blas/lapack ?
	Create and fill a Matrix then fallback to matrix operation
	this is not fully optimized"

	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat - (mat class 
						nrow: mat nrow
						ncol: mat ncol
						withAll: num)]! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:01'!
productFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | mat scaledByNumber: num]! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:02'!
quotientFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | mat scaledByNumber: num reciprocal]! !

!Number methodsFor: '*Smallapack-Matrix-testing' stamp: 'nice 5/20/2006 01:39'!
respondsToArithmetic
	"this is a VW compatibility message used by Smallapack"
	
	^true! !

!Number methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 04:01'!
sumFromLapackMatrix: aMatrix 
	"No such function available in blas/lapack ?
	Create and fill a Matrix then fallback to matrix operation
	this is not fully optimized"

	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat + (mat class 
						nrow: mat nrow
						ncol: mat ncol
						withAll: num)]! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/20/2006 23:49'!
asDoubleComplex
	^real asFloat i: imaginary asFloat! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/21/2006 01:33'!
asFloat
	^self asFloatComplex! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/20/2006 23:48'!
asFloatComplex
	^real asFloat i: imaginary asFloat! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/20/2006 03:01'!
asLapackMatrix
	^LapackZGEMatrix 
		fromSequence: (ExternalDoubleComplexArray with: self)
		nrow: 1
		ncol: 1! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/23/2006 23:29'!
coercing: aMatrix do: aBlock 
	imaginary isZero ifTrue: [^real coercing: aMatrix do: aBlock].
	^aMatrix coercingFromComplexNumber: self asDoubleComplex do: aBlock! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 03:58'!
concatColumnsFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat concatColumnsWithLapackMatrix: (mat class 
						nrow: 1
						ncol: 1
						withAll: self)]! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 03:58'!
concatRowsFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat concatRowsWithLapackMatrix: (mat class 
						nrow: 1
						ncol: 1
						withAll: self)]! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 03:57'!
differenceFromLapackMatrix: aMatrix 
	"No such function available in blas/lapack ?
	Create and fill a Matrix then fallback to matrix operation
	this is not fully optimized"

	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat - (mat class 
						nrow: mat nrow
						ncol: mat ncol
						withAll: num)]! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 03:59'!
productFromLapackMatrix: aMatrix 
	^self coercing: aMatrix do: [:num :mat | mat scaledByComplex: num]! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: ''!
quotientFromLapackMatrix: aMatrix 
	^self coercing: aMatrix
		do: 
			[:num :mat | mat scaledByComplex: num reciprocal]! !

!Complex methodsFor: '*Smallapack-Matrix-converting' stamp: 'nice 5/21/2006 01:31'!
reduce
	imaginary isZero ifTrue: [^real reduce]! !

!Complex methodsFor: '*Smallapack-Matrix-testing' stamp: 'nice 5/20/2006 01:40'!
respondsToArithmetic
	"this is a VW compatibility message used by Smallapack"
	
	^true! !

!Complex methodsFor: '*Smallapack-Matrix-double dispatching' stamp: 'nice 2/16/2006 03:58'!
sumFromLapackMatrix: aMatrix 
	"No such function available in blas/lapack ?
	Create and fill a Matrix then fallback to matrix operation
	this is not fully optimized"

	^self coercing: aMatrix
		do: 
			[:num :mat | 
			mat + (mat class 
						nrow: mat nrow
						ncol: mat ncol
						withAll: num)]! !

!FloatArray methodsFor: '*Smallapack-Matrix' stamp: 'nice 5/14/2006 23:51'!
asLapackMatrixNrow: nr ncol: nc 
	^LapackSGEMatrix 
		fromSequence: self copy
		nrow: nr
		ncol: nc! !

!ExternalFloatComplexArray methodsFor: '*Smallapack-Matrix' stamp: 'nice 5/20/2006 01:01'!
asLapackMatrixNrow: nr ncol: nc 
	^LapackCGEMatrix 
		fromSequence: self copy
		nrow: nr
		ncol: nc! !

!ExternalFloatArray methodsFor: '*Smallapack-Matrix' stamp: 'nice 5/20/2006 01:01'!
asLapackMatrixNrow: nr ncol: nc 
	^LapackSGEMatrix 
		fromSequence: self copy
		nrow: nr
		ncol: nc! !

!ExternalDoubleComplexArray methodsFor: '*Smallapack-Matrix' stamp: 'nice 5/20/2006 01:00'!
asLapackMatrixNrow: nr ncol: nc 
	^LapackZGEMatrix 
		fromSequence: self copy
		nrow: nr
		ncol: nc! !

Object subclass: #AbstractMatrix
	instanceVariableNames: 'array nrow ncol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!AbstractMatrix commentStamp: '<historical>' prior: 0!
AbstractMatrix is the abstract superclass for common Matrix protocol

AbstractMatrix have a number of elements equal to its number of rows times its number of columns.
The elements are stored in a flat (Array of Number) rather than in an (Array of: (Array of: Number)).
Elements are ordered with column-major order (like FORTRAN and Matlab).
This arbitrary tyrannic implementation choice isn't mine;
It comes from the fact that original LAPACK BLAS libraries are written in FORTRAN.

Instance Variables:
	array	<SequenceableCollection>	hold elements of the matrix
	ncol	<Integer>	number of columns
	nrow	<Integer>	number of rows

!

!AbstractMatrix class methodsFor: 'private' stamp: ''!
allocateNrow: nr ncol: nc 
	"Allocate the array, but do not initialize its contents"

	^self basicNew 
		setArray: (Array new: nr * nc)
		nrow: nr
		ncol: nc! !

!AbstractMatrix class methodsFor: 'private' stamp: ''!
allocateShape: aShape 
	"Allocate the array, but do not initialize its contents"

	^self shape: aShape do: [:nr :nc | self allocateNrow: nr ncol: nc]! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
column: aSequenceableCollection
	"Form a Matrix with a single column from a collection
	This is Squeak-Matrix compatible"

	^self columns: (Array with: aSequenceableCollection)! !

!AbstractMatrix class methodsFor: 'converting' stamp: ''!
columnMatrix
	^self! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
columns: anArrayOfColumns 
	"Form a Matrix from an Array of columns.
	Each column should have same number of elements"

	| nr nc mat |
	anArrayOfColumns isEmpty ifTrue: [^self nrow: 0 ncol: 0].
	nc := anArrayOfColumns size.
	nr := anArrayOfColumns first size.
	(anArrayOfColumns allSatisfy: [:each | each size = nr]) 
		ifFalse: [self error: 'Not a conformant array of columns'].
	mat := self nrow: nr ncol: nc.
	mat columns: anArrayOfColumns.
	^mat! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
diagonal: aSequenceOfNumber 
	"Form a diagonal Matrix from a collection"

	| n mat |
	n := aSequenceOfNumber size.
	mat := self nrow: n ncol: n.
	mat setDiagonal: aSequenceOfNumber.
	^mat! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
dimensions: anIntegerOrPointOrArrayOfInteger 
	"Synonym"

	^self shape: anIntegerOrPointOrArrayOfInteger! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
eye: anIntegerOrPointOrArrayOfInteger 
	"Create eye (identity) matrix"

	| res |
	res := self shape: anIntegerOrPointOrArrayOfInteger.
	res setToEye.
	^res! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
fromSequence: aSequenceableCollection nrow: nr ncol: nc 
	"Create a matrix from a collection
	BEWARE:
	- elements ordering in the collection should be column-major
	- no copy of the collection is made: the collection might be modified whenever the Matrix will be modified
	  However, user cannot rely on this feature, it will not always be true."

	^(aSequenceableCollection isSequenceable and: [ aSequenceableCollection size = (nr * nc)]) 
			ifTrue: 
				[self basicNew 
					setArray: aSequenceableCollection
					nrow: nr
					ncol: nc]
			ifFalse: 
				[self error: #badArraySpecification << #Smallapack 
							>> 'Bad sequenceableCollection specification for creating a Matrix']! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
identity: anIntegerOrPointOrArrayOfInteger 
	"Form a square or not square identity Matrix of dimensions specified by anIntegerOrPointOrArrayOfInteger
	Example
		AbstractMatrix identity: 3.
		AbstractMatrix identity: 3 @ 2.
		AbstractMatrix identity: #(3 2).
	This is Squeak-Matrix compatible"

	^self eye: anIntegerOrPointOrArrayOfInteger! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
nRows: numRows nCols: numCols 
	"Synonym Smallpack-compatible protocol"

	^self nrow: numRows ncol: numCols! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
ncol: nc
	"create a row matrix filled with 0"

	^self rowMatrix
		nrow: 1
		ncol: nc
		withAll: 0! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
new: anInteger
	"behave like a Collection. I will answer anInteger as my size.
	Since I am column-major, favor a column
	WARNING: THIS IS NOT COMPATIBLE WITH SQUEAK nor NUMERICAL METHODS
	BUT MORE CONSISTENT WITh SEQUENCEABLE COLLECTION
	use shape: anInteger to get equivalent behavior"

	^self ncol: anInteger! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
nrow: nr
	"create a column matrix filled with 0"

	^self columnMatrix
		nrow: nr
		ncol: 1
		withAll: 0! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
nrow: nr ncol: nc 
	"create a matrix filled with 0"

	^self 
		nrow: nr
		ncol: nc
		withAll: 0! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: 'nice 2/18/2006 14:41'!
nrow: nrow ncol: ncol tabulate: aBlock 
	"Answer a new Matrix of the given dimensions where
	 result at: i at: j     is   aBlock value: i value: j
	Borrowed from Squeak.Matrix
	Beware: unlike Squeak, this class is column-major-ordered"

	| a i |
	a := self nrow: nrow ncol: ncol.
	i := 0.
	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: [:row | a at: (i := i + 1) put: (aBlock value: row value: column)]].
	^a! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
nrow: nr ncol: nc withAll: aNumber 
	"Create a matrix filled with aNumber
	This is analog the the ArrayedCollection>>new:withAll: , not the Collection>>withAll:"

	^self basicNew 
		setArray: (Array new: nr * nc withAll: aNumber)
		nrow: nr
		ncol: nc! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
ones: anIntegerOrPointOrArrayOfInteger 
	"Form a Matrix filled with 1 of dimensionsof dimensions specified by anIntegerOrPointOrArrayOfInteger
	Example
		AbstractMatrix ones: 3.
		AbstractMatrix ones: 3 @ 2.
		AbstractMatrix ones: #(3 2).
	This is Squeak-Matrix compatible"

	^self shape: anIntegerOrPointOrArrayOfInteger
		do: 
			[:nrow :ncol | 
			self 
				nrow: nrow
				ncol: ncol
				withAll: 1]! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
row: aSequenceableCollection
	"Form a Matrix with a single row from a collection
	This is Squeak-Matrix compatible"

	^self rows: (Array with: aSequenceableCollection)! !

!AbstractMatrix class methodsFor: 'converting' stamp: ''!
rowMatrix
	^self! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
rows: anArrayOfRows 
	"Form a Matrix from an Array of rows.
	Each row should have same number of elements"

	| nr nc mat |
	anArrayOfRows isEmpty ifTrue: [^self nrow: 0 ncol: 0].
	nr := anArrayOfRows size.
	nc := anArrayOfRows first size.
	(anArrayOfRows allSatisfy: [:each | each size = nc]) 
		ifFalse: [self error: 'Not a conformant array of rows'].
	mat := self nrow: nr ncol: nc.
	mat rows: anArrayOfRows.
	^mat! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
rows: rows columns: columns 
	"Synonym Squeak-Matrix-compatible protocol"

	^self nrow: rows ncol: columns! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: 'nice 2/18/2006 14:42'!
rows: rows columns: columns contents: contents 
	"Synonym Squeak-Matrix-compatible protocol
	BEWARE:
		in Squeak Matrix, order is row-major
		in Smallapack, order is column-major
	Assume the contents is Smallapack-column-major"

	^self 
		fromSequence: contents
		nrow: rows
		ncol: columns! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
rows: rows columns: columns element: element 
	"Synonym Squeak-Matrix-compatible protocol"

	^self 
		nrow: rows
		ncol: columns
		withAll: element! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
rows: rows columns: columns tabulate: aBlock 
	"Synonym Squeak-Matrix-compatible protocol"

	^self 
		nrow: rows
		ncol: columns
		tabulate: aBlock! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
shape: anIntegerOrPointOrArrayOfInteger 
	"Form a Matrix of dimensions (or shape) :
		either square anInteger * anInteger
		or aPoint x*aPoint y
		or anArrayOfInteger first*anArrayOfInteger last
	Depending on argument class"

	^self shape: anIntegerOrPointOrArrayOfInteger
		do: [:nrow :ncol | self nrow: nrow ncol: ncol]! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
shape: anIntegerOrPointOrArrayOfInteger do: aBlock 
	"Extract the dimensions (or shape) :
		either square anInteger * anInteger
		or aPoint x*aPoint y
		or anArrayOfInteger first*anArrayOfInteger last
	And evaluate aBlock with: nrow with: ncol"

	^anIntegerOrPointOrArrayOfInteger isInteger 
		ifTrue: 
			[aBlock value: anIntegerOrPointOrArrayOfInteger
				value: anIntegerOrPointOrArrayOfInteger]
		ifFalse: 
			[anIntegerOrPointOrArrayOfInteger isSequenceable 
				ifTrue: 
					[(anIntegerOrPointOrArrayOfInteger size between: 1 and: 2) 
						ifTrue: 
							[aBlock value: anIntegerOrPointOrArrayOfInteger first
								value: anIntegerOrPointOrArrayOfInteger last]
						ifFalse: 
							[self 
								error: 'dimensions: should be called with a collection of 1 or 2 integers']]
				ifFalse: 
					["Assume the argument is aPoint"

					aBlock value: anIntegerOrPointOrArrayOfInteger x
						value: anIntegerOrPointOrArrayOfInteger y]]! !

!AbstractMatrix class methodsFor: 'instance creation' stamp: ''!
zeros: anIntegerOrPointOrArrayOfInteger 
	"Form a Matrix filled with 0 of dimensions specified by anIntegerOrPointOrArrayOfInteger
	Example
		AbstractMatrix zeros: 3.
		AbstractMatrix zeros: 3 @ 2.
		AbstractMatrix zeros: #(3 2).
	This is Squeak-Matrix compatible"

	^(self shape: anIntegerOrPointOrArrayOfInteger)
		"atAllPut: 0; This is the default behaviour; do not do it again"
		yourself! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
* aMatrix 
	^aMatrix productFromMatrix: self! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
+ aMatrix 
	^aMatrix sumFromMatrix: self! !

!AbstractMatrix methodsFor: 'concatenating' stamp: ''!
, aMatrix 
	^aMatrix concatColumnsFromMatrix: self! !

!AbstractMatrix methodsFor: 'concatenating' stamp: ''!
,, aMatrix 
	^aMatrix concatRowsFromMatrix: self! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
- aMatrix 
	^aMatrix differenceFromMatrix: self! !

!AbstractMatrix methodsFor: 'comparing' stamp: ''!
= aMatrix 
	(aMatrix respondsToArithmetic 
		and: [aMatrix isMatrix and: [nrow = aMatrix nrow and: [ncol = aMatrix ncol]]]) 
			ifFalse: [^false].
	1 to: self size
		do: [:i | (self at: i) = (aMatrix at: i) ifFalse: [^false]].
	^true! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
abs
	^self collect: [:e | e abs]! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
absMax
	"Note: for matrices, this does not have norm properties"

	^self maxOf: [:e | e abs]! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:21'!
adaptToComplex: rcvr andSend: selector 
	"If I am involved in arithmetic with a Complex."

	selector = #* ifTrue: [^self asComplexMatrix scaledByComplex: rcvr].
	^self asComplexMatrix collect:  [:each | rcvr perform: selector with: each]! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 3/28/2006 23:12'!
adaptToFloat: rcvr andCompare: selector 
	"If I am involved in arithmetic with a Fraction."
	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:22'!
adaptToFloat: rcvr andSend: selector 
	"If I am involved in arithmetic with a Float."

	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:22'!
adaptToFraction: rcvr andSend: selector 
	"If I am involved in arithmetic with a Fraction."
	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 3/28/2006 23:13'!
adaptToInteger: rcvr andCompare: selector 
	"If I am involved in arithmetic with a Fraction."
	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:22'!
adaptToInteger: rcvr andSend: selector 
	"If I am involved in arithmetic with an Integer."
	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 5/21/2006 00:35'!
adaptToNumber: rcvr andSend: selector 
	"If I am involved in arithmetic with a Fraction."

	selector = #* ifTrue: [^self scaledByNumber: rcvr].
	^self collect:  [:each | rcvr perform: selector with: each]! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:22'!
adaptToScaledDecimal: rcvr andSend: selector 
	"If I am involved in arithmetic with a ScaledDecimal."
	^self adaptToNumber: rcvr andSend: selector ! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
allSatisfy: aBlock 
	1 to: self size
		do: [:i | (aBlock value: (self at: i)) ifFalse: [^false]].
	^true! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
anySatisfy: aBlock 
	1 to: self size
		do: [:i | (aBlock value: (self at: i)) ifTrue: [^true]].
	^false! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
appendColumns: nColumns 
	| res |
	res := self class nrow: nrow ncol: ncol + nColumns.
	res 
		copy: nrow
		rowsStartingAt: 1
		and: ncol
		columnsStartingAt: 1
		from: self.
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
appendRows: nRows 
	| res |
	res := self class nrow: nrow + nRows ncol: ncol.
	res 
		copy: nrow
		rowsStartingAt: 1
		and: ncol
		columnsStartingAt: 1
		from: self.
	^res! !

!AbstractMatrix methodsFor: 'private' stamp: 'nice 8/2/2006 22:21'!
arrayAt: anInteger
	"access underlying storage with specific storage order"
	
	^array at: anInteger! !

!AbstractMatrix methodsFor: 'private' stamp: 'nice 8/2/2006 22:21'!
arrayAt: anInteger put: aNumber
	"access underlying storage with specific storage order"
	
	^array at: anInteger put: aNumber! !

!AbstractMatrix methodsFor: 'private' stamp: 'nice 8/2/2006 22:22'!
arrayOffsetAtRow: rowIndex atColumn: columnIndex 
	"Answer an offset (0-based) to be used in storage specific access"

	^(columnIndex - 1) * nrow + rowIndex - 1! !

!AbstractMatrix methodsFor: 'private' stamp: ''!
arraySize
	^array size! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asAbstractMatrix
	^self! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asArray
	| result |
	result := array asArray.
	^result == array ifTrue: [result copy] ifFalse: [result]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asBag
	| aBag |
	aBag := Bag new.
	self do: [:each | aBag add: each].
	^aBag! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 8/31/2011 23:22'!
asColumnMatrix
	^ncol = 1 
		ifTrue: [self]
		ifFalse: 
			[| res |
			res := self class nrow: self size.
			1 to: self size do: [:i | res at: i put: (self at: i)].
			^res]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asDoubleComplexMatrix
	^self asDoublePrecisionComplexMatrix! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asDoubleMatrix
	^self asDoublePrecisionMatrix! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asDoublePrecisionComplexMatrix
	| res |
	res := LapackZGEMatrix allocateNrow: nrow ncol: ncol.
	1 to: self size do: [:i | res at: i put: (self at: i) asDoubleComplex].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 5/15/2006 23:01'!
asDoublePrecisionMatrix
	| res |
	res := LapackDGEMatrix allocateNrow: nrow ncol: ncol.
	1 to: self size do: [:i | res at: i put: (self at: i) asFloat].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asFloatComplexMatrix
	^self asSinglePrecisionComplexMatrix! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asFloatMatrix
	^self asSinglePrecisionMatrix! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asMatrix
	^self! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asOrderedCollection
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: self size.
	self do: [:each | anOrderedCollection addLast: each].
	^anOrderedCollection! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 8/31/2011 23:22'!
asRowMatrix
	^nrow = 1 
		ifTrue: [self]
		ifFalse: 
			[| res |
			res := self class ncol: self size.
			1 to: self size do: [:i | res at: i put: (self at: i)].
			res]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asSet
	| aSet |
	aSet := Set new.
	self do: [:each | aSet add: each].
	^aSet! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asSinglePrecisionComplexMatrix
	| res |
	res := LapackCGEMatrix allocateNrow: nrow ncol: ncol.
	1 to: self size do: [:i | res at: i put: (self at: i) asFloatComplex].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asSinglePrecisionMatrix
	| res |
	res := LapackSGEMatrix allocateNrow: nrow ncol: ncol.
	1 to: self size do: [:i | res at: i put: (self at: i) asFloat].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asSortedCollection
	| aSortedCollection |
	aSortedCollection := SortedCollection new: self size.
	aSortedCollection addAll: self.
	^aSortedCollection! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
asSortedCollection: aBlock 
	| aSortedCollection |
	aSortedCollection := SortedCollection new: self size.
	aSortedCollection sortBlock: aBlock.
	aSortedCollection addAll: self.
	^aSortedCollection! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger
	"Access the underlying array
	should be overloaded if packed storage is used"

	^array at: anInteger! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: rowIndex at: columnIndex 
	"Squak compatible"

	^self rowAt: rowIndex columnAt: columnIndex! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: r at: c ifInvalid: v
	"If r,c is a valid index for this matrix, answer the corresponding element.
	 Otherwise, answer v value.
	Squeak compatible - I added the message v value: this enables using aBlock"

	(r between: 1 and: nrow) ifFalse: [^v value].
	(c between: 1 and: ncol) ifFalse: [^v value].
	^self rowAt: r columnAt: c! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: row at: column incrementBy: value 
	"Squeak compatible message"

	^self 
		rowAt: row
		columnAt: column
		put: (self rowAt: row columnAt: column) + value! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: rowIndex at: columnIndex put: aNumber
	"Squak compatible"

	^self rowAt: rowIndex columnAt: columnIndex put: aNumber! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger put: aNumber 
	"Access the underlying array
	should be overloaded if packed storage is used"

	^array at: anInteger put: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atAllPut: aNumber 
	"Put aNumber at every one of the receiver's indices."

	1 to: self size do: [:index | self at: index put: aNumber]! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atColumn: columnIndex 
	"synonym"

	^self columnAt: columnIndex! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atColumn: colIndex put: aCollection 
	"Synonym Squeak-Matrix-Compatible"

	^self atColumn: colIndex putSequence: aCollection! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atColumn: columnIndex putAll: aNumber 
	"synonym"

	^self columnAt: columnIndex putAll: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atColumn: colIndex putSequence: aCollection 
	1 to: aCollection size
		do: 
			[:each | 
			self 
				rowAt: each
				columnAt: colIndex
				put: (aCollection at: each)]! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atColumns: columnsIndexCollection 
	| res j |
	res := self class allocateNrow: nrow ncol: columnsIndexCollection size.
	j := 0.
	columnsIndexCollection 
		do: [:i | res columnAt: (j := j + 1) putSequence: (self columnAt: i)].
	^res! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atInteger: anInteger
	"Access the underlying array"

	^self at: anInteger! !

!AbstractMatrix methodsFor: 'accessing' stamp: 'nice 8/2/2006 22:23'!
atInteger: rowIndex andInteger: columnIndex 
	"Access a specific element"

	^self at: (columnIndex - 1) * nrow + rowIndex! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atInteger: rowIndex andInteger: columnIndex put: aNumber
	"Access the underlying array"

	^self at: (columnIndex - 1) * nrow + rowIndex put: aNumber! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atInteger: anInteger put: aNumber
	"Access the underlying array"

	^self at: anInteger put: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atIntervalFrom: interStart to: interStop by: interStep 
	"Extract a copy of a subinterval of self"

	| sz result |
	sz := (interStop - interStart) // interStep + 1 max: 0.
	result := nrow = 1 
				ifTrue: [self class ncol: sz]
				ifFalse: [ncol = 1 ifTrue: [self class nrow: sz] ifFalse: [Array new: sz]].
	1 to: sz
		do: [:i | result at: i put: (self at: interStart + ((i - 1) * interStep))].
	^result! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atPoint: aPoint 
	"some implementations use Points to access 2D tables"

	^self rowAt: aPoint x columnAt: aPoint y! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atPoint: aPoint put: aNumber
	"some implementations use Points to access 2D tables"

	^self rowAt: aPoint x columnAt: aPoint y put: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atRow: rowIndex 
	"synonym"

	^self rowAt: rowIndex! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atRow: rowIndex column: columnIndex 
	"synonym"

	^self rowAt: rowIndex columnAt: columnIndex! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
atRow: rowIndex column: columnIndex put: aNumber 
	"synonym"

	^self 
		rowAt: rowIndex
		columnAt: columnIndex
		put: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atRow: colIndex put: aCollection 
	"Synonym Squeak-Matrix-Compatible"

	^self atRow: colIndex putSequence: aCollection! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atRow: rowIndex putAll: aNumber 
	"synonym"

	^self rowAt: rowIndex putAll: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atRow: rowIndex putSequence: aCollection 
	"synonym"

	^self rowAt: rowIndex putSequence: aCollection! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
atRows: rowsIndexCollection 
	| res j |
	res := self class allocateNrow: rowsIndexCollection size ncol: ncol.
	j := 0.
	rowsIndexCollection 
		do: [:i | res rowAt: (j := j + 1) putSequence: (self rowAt: i)].
	^res! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 8/31/2011 23:52'!
atRows: rowsIndexCollection atColumns: columnIndexCollection
	| res |
	res := self class allocateNrow: rowsIndexCollection size ncol: columnIndexCollection size.
	columnIndexCollection keysAndValuesDo: [:j :jCol |
		rowsIndexCollection  keysAndValuesDo: [:i :iRow |
			res rowAt: i columnAt: j put: (self rowAt: iRow columnAt: jCol)]].
	^res! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
capacity
	^nrow * ncol! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
collect: aBlock 
	| result |
	result := self class allocateNrow: nrow ncol: ncol.
	1 to: self size
		do: [:i | result at: i put: (aBlock value: (self at: i))].
	^result! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
columnAt: columnIndex 
	^(self 
		atIntervalFrom: (columnIndex - 1) * nrow + 1
		to: columnIndex * nrow
		by: 1) asColumnMatrix! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
columnAt: columnIndex putAll: aNumber 
	1 to: nrow
		do: 
			[:each | 
			self 
				rowAt: each
				columnAt: columnIndex
				put: aNumber]! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
columnAt: colIndex putSequence: aCollection 
	1 to: aCollection size
		do: 
			[:each | 
			self 
				rowAt: each
				columnAt: colIndex
				put: (aCollection at: each)]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
columnCount
	"Squeak compatible"

	^ncol! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
columns
	^(1 to: ncol) collect: [:columnIndex | self columnAt: columnIndex]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
columns: anArrayOfColumns 
	1 to: anArrayOfColumns size
		do: [:columnIndex | self columnAt: columnIndex putSequence: (anArrayOfColumns at: columnIndex)]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
columnsDo: aBlock 
	"evaluate aBlock with each column"

	1 to: ncol do: [:i | aBlock value: (self columnAt: i)]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
concatColumnsFromLapackMatrix: aLapackMatrix
	^self concatColumnsFromMatrix: aLapackMatrix! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
concatColumnsFromMatrix: aMatrix 
	^aMatrix concatColumnsWithMatrix: self! !

!AbstractMatrix methodsFor: 'concatenating' stamp: ''!
concatColumnsWithMatrix: aMatrix 
	"Generic code"

	| res |
	self size = 0 ifTrue: [^aMatrix copy].
	aMatrix size = 0 ifTrue: [^self copy].
	aMatrix nrow = nrow 
		ifFalse: [self error: 'cannot concatenate columns if not same number of rows'].
	res := self class allocateNrow: nrow ncol: ncol + aMatrix ncol.
	res 
		copy: self size
		elementsFrom: self
		sourceIncrement: 1
		destIncrement: 1.
	res 
		copy: aMatrix size
		elementsFrom: aMatrix
		sourceOffset: 0
		sourceIncrement: 1
		destOffset: self size
		destIncrement: 1.
	^res! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
concatRowsFromLapackMatrix: aLapackMatrix
	^self concatRowsFromMatrix: aLapackMatrix! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
concatRowsFromMatrix: aMatrix 
	^aMatrix concatRowsWithMatrix: self! !

!AbstractMatrix methodsFor: 'concatenating' stamp: ''!
concatRowsWithMatrix: aMatrix 
	"Generic implementation"

	| res |
	self size = 0 ifTrue: [^aMatrix copy].
	aMatrix size = 0 ifTrue: [^self copy].
	aMatrix ncol = ncol 
		ifFalse: [self error: 'cannot concatenate rows if not same number of columns'].
	res := self class allocateNrow: nrow + aMatrix nrow ncol: ncol.
	res 
		copy: nrow
		rowsStartingAt: 1
		and: ncol
		columnsStartingAt: 1
		from: self.
	res 
		copy: aMatrix nrow
		rowsStartingAt: nrow + 1
		and: ncol
		columnsStartingAt: 1
		from: aMatrix.
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
conjugated
	^self collect: [:e | e conjugated]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
copy: n elementsFrom: aMatrix sourceIncrement: incx destIncrement: incy 
	"BLAS primitve xCOPY - naive implementation"

	^self 
		copy: n
		elementsFrom: aMatrix
		sourceOffset: 0
		sourceIncrement: incx
		destOffset: 0
		destIncrement: incy! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
copy: n elementsFrom: aMatrix sourceOffset: offx sourceIncrement: incx destOffset: offy destIncrement: incy 
	"BLAS primitve xCOPY - naive implementation"

	| sx sy |
	sx := incx positive ifTrue: [offx + 1] ifFalse: [(1 - n) * incx + offx + 1].
	sy := incy positive ifTrue: [offy + 1] ifFalse: [(1 - n) * incy + offy + 1].
	0 to: n - 1
		do: 
			[:i | 
			self at: i * incy + sy
				put: (aMatrix at: i * incx + sx)]! !

!AbstractMatrix methodsFor: 'private-lapack' stamp: ''!
copy: m rowsStartingAt: i and: n columnsStartingAt: j from: a 
	"Equivalent Matlab code:
		self( i:i+m-1 , j:j+n-1 ) = a(1:m , 1:n)
	subclass would use auxiliary lapack routine"

	1 to: n
		do: 
			[:jc | 
			1 to: m
				do: 
					[:ir | 
					self at: (j + jc - 2) * nrow + i + ir - 1
						put: (a at: (jc - 1) * a nrow + ir)]]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 2/18/2006 14:39'!
count: aBlock 
	"Count the number of elements that satisfy a condition.
	anElement is satisfying a condition means
	(aBlock value: anElement) = true."

	| count |
	count := 0.
	1 to: self size
		do: [:i | (aBlock value: (self at: i)) ifTrue: [count := count + 1]].
	^count! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
cumulativeProduct: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: ncol.
			1 to: nrow
				do: 
					[:i | 
					res rowAt: i
						putSequence: ((1 to: ncol) 
								cumulativeProduct: [:j | aBlock value: (self rowAt: i columnAt: j)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: ncol.
			1 to: ncol
				do: 
					[:i | 
					res columnAt: i
						putSequence: ((1 to: nrow) 
								cumulativeProduct: [:j | aBlock value: (self rowAt: j columnAt: i)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
cumulativeSum: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: ncol.
			1 to: nrow
				do: 
					[:i | 
					res rowAt: i
						putSequence: ((1 to: ncol) 
								cumulativeSum: [:j | aBlock value: (self rowAt: i columnAt: j)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: ncol.
			1 to: ncol
				do: 
					[:i | 
					res columnAt: i
						putSequence: ((1 to: nrow) 
								cumulativeSum: [:j | aBlock value: (self rowAt: j columnAt: i)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonal
	"Answer a Column Matrix with elements extracted from my diagonal.
	This is not compatible with Matlab function diag.
	Matlab code would be:
		^self isVector
			ifTrue: [self clas diagonal: self]
			ifFalse: [self diagonalAt: 0]"

	^self diagonalAt: 0! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	"Answer a Column Matrix with elements extracted from :
	- my diagonal if index is 0
	- super diagonal (upper right) number index if index > 0
	- sub diagonal (lower left) number index negated if index < 0
	This is not compatible with Matlab function diag"

	| diag |
	index >= 0 
		ifTrue: 
			[diag := self class nrow: (self diagonalSizeAt: index).
			1 to: diag size
				do: [:i | diag at: i put: (self rowAt: i columnAt: i + index)]]
		ifFalse: 
			[diag := self class nrow: (self diagonalSizeAt: index).
			1 to: diag size
				do: [:i | diag at: i put: (self rowAt: i - index columnAt: i)]].
	^diag! !

!AbstractMatrix methodsFor: 'private' stamp: ''!
diagonalSizeAt: index 
	"answer the size of a diagonal"

	^index >= 0 
		ifTrue: [nrow min: ncol - index]
		ifFalse: [nrow + index min: ncol]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromComplex: aComplex 
	^self collect: [:each | aComplex - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromDouble: aDouble 
	^self collect: [:each | aDouble - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromFixedPoint: aFixedPoint 
	^self collect: [:each | aFixedPoint - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromFloat: aFloat 
	^self collect: [:each | aFloat - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromFraction: aFraction 
	^self collect: [:each | aFraction - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromInteger: anInteger 
	^self collect: [:each | anInteger - each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromLapackMatrix: aLapackMatrix
	^self differenceFromMatrix: aLapackMatrix asGeneralMatrix! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromMatrix: aMatrix 
	| res |
	(nrow = aMatrix nrow and: [ncol = aMatrix ncol]) 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: self size
		do: [:i | res at: i put: (aMatrix at: i) - (self at: i)].
	^res! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
dimensions
	^Array with: nrow with: ncol! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
do: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument."

	1 to: self size do: [:i | aBlock value: (self at: i)]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
dotProduct: n elementsIncrement: incx with: aMatrix increment: incy 
	"BLAS primitve xDOT - naive implementation"

	| sx sy |
	sx := incx positive ifTrue: [1] ifFalse: [(1 - n) * incx + 1].
	sy := incy positive ifTrue: [ 1] ifFalse: [(1 - n) * incy +1].
	^(1 to: n) sum: 
			[:i | 
			(self at: (i - 1) * incx + sx) 
				* (aMatrix at: (i - 1) * incy + sy)]! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 8/2/2006 22:14'!
elementwisePowerFromNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (aNumber raisedTo: (res rowAt: ir columnAt: jc))]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 8/2/2006 22:14'!
elementwisePowerWithMatrix: aMatrix 
	| res |
	(aMatrix nrow = nrow and: [aMatrix ncol = ncol]) 
		ifFalse: [self error: 'matrix size mismatch'].
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: ((res rowAt: ir columnAt: jc) raisedTo: (aMatrix rowAt: ir columnAt: jc))]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 8/2/2006 22:15'!
elementwisePowerWithNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: ((res rowAt: ir columnAt: jc) raisedTo: aNumber)]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseProductFromNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: aNumber * (res rowAt: ir columnAt: jc)]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseProductWithMatrix: aMatrix 
	| res |
	(aMatrix nrow = nrow and: [aMatrix ncol = ncol]) 
		ifFalse: [self error: 'matrix size mismatch'].
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (res rowAt: ir columnAt: jc) * (aMatrix rowAt: ir columnAt: jc)]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseProductWithNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (res rowAt: ir columnAt: jc) * aNumber]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseQuotientFromNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: aNumber / (res rowAt: ir columnAt: jc)]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseQuotientWithMatrix: aMatrix 
	| res |
	(aMatrix nrow = nrow and: [aMatrix ncol = ncol]) 
		ifFalse: [self error: 'matrix size mismatch'].
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (res rowAt: ir columnAt: jc) / (aMatrix rowAt: ir columnAt: jc)]].
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseQuotientWithNumber: aNumber 
	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (res rowAt: ir columnAt: jc) / aNumber]].
	^res! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
fill: n elementsWithStride: incy withSelfPlusScalar: alpha timesVector: aMatrix stride: incx 
	"BLAS primitve xAXPY - naive implementation"

	| sx sy |
	sx := incx positive ifTrue: [1] ifFalse: [(1 - n) * incx + 1].
	sy := incy positive ifTrue: [1] ifFalse: [(1 - n) * incy + 1].
	1 to: n
		do: 
			[:i | 
			self at: (i - 1) * incx + sx
				put: (self at: (i - 1) * incx + sx) 
						+ (alpha * (aMatrix at: (i - 1) * incy + sy))]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
fill: m elementsWithStride: incy withSelfScaledBy: beta plusScalar: alpha timesMatrix: a transposed: trans timesVector: x length: n stride: incx 
	"BLAS primitve xGEMV - naive implementation"

	| sx sy |
	sx := incx positive ifTrue: [1] ifFalse: [(1 - n) * incx + 1].
	sy := incy positive ifTrue: [1] ifFalse: [(1 - m) * incy + 1].
	trans 
		ifTrue: 
			[1 to: m
				do: 
					[:i | 
					self at: (i - 1) * incy + sy
						put: alpha * ((1 to: n) 
										sum: [:j | (a rowAt: j columnAt: i) * (x at: (j - 1) * incx + sx)]) 
								+ (beta * (self at: (i - 1) * incy + sy))]]
		ifFalse: 
			[1 to: m
				do: 
					[:i | 
					self at: (i - 1) * incy + sy
						put: alpha * ((1 to: n) 
										sum: [:j | (a rowAt: i columnAt: j) * (x at: (j - 1) * incx + sx)]) 
								+ (beta * (self at: (i - 1) * incy + sy))]]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
fillM: m byN: n withScalar: alpha timesColumnVector: x stride: incx timesRowVector: y stride: incy 
	"Blas library xGERx 
	fill mxn elements of self from following m-length x and a n-length y vector product
		alpha*x*transpose(y)"

	| sx sy |
	sx := incx positive ifTrue: [1] ifFalse: [(1 - m) * incx + 1].
	sy := incy positive ifTrue: [1] ifFalse: [(1 - n) * incy + 1].
	1 to: n
		do: 
			[:j | 
			1 to: m
				do: 
					[:i | 
					self 
						rowAt: i
						columnAt: j
						put: alpha * (x at: (i - 1) * incx + sx) 
								* (y at: (j - 1) * incy + sy)]]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
fillM: m byN: n withSelfScaledBy: beta plusScalar: alpha timesLeftMatrix: a transposed: transa timesRightMatrix: b transposed: transb length: k 
	"BLAS primitve xGEMM - naive implementation"

	transa 
		ifTrue: 
			[transb 
				ifTrue: 
					[1 to: n
						do: 
							[:j | 
							1 to: m
								do: 
									[:i | 
									self 
										rowAt: i
										columnAt: j
										put: alpha * ((1 to: k) 
														sum: [:kk | (a rowAt: kk columnAt: i) * (b rowAt: j columnAt: kk)]) 
												+ (beta * (self rowAt: i columnAt: j))]]]
				ifFalse: 
					[1 to: n
						do: 
							[:j | 
							1 to: m
								do: 
									[:i | 
									self 
										rowAt: i
										columnAt: j
										put: alpha * ((1 to: k) 
														sum: [:kk | (a rowAt: kk columnAt: i) * (b rowAt: kk columnAt: j)]) 
												+ (beta * (self rowAt: i columnAt: j))]]]]
		ifFalse: 
			[transb 
				ifTrue: 
					[1 to: n
						do: 
							[:j | 
							1 to: m
								do: 
									[:i | 
									self 
										rowAt: i
										columnAt: j
										put: alpha * ((1 to: k) 
														sum: [:kk | (a rowAt: i columnAt: kk) * (b rowAt: j columnAt: kk)]) 
												+ (beta * (self rowAt: i columnAt: j))]]]
				ifFalse: 
					[1 to: n
						do: 
							[:j | 
							1 to: m
								do: 
									[:i | 
									self 
										rowAt: i
										columnAt: j
										put: alpha * ((1 to: k) 
														sum: [:kk | (a rowAt: i columnAt: kk) * (b rowAt: kk columnAt: j)]) 
												+ (beta * (self rowAt: i columnAt: j))]]]]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
findMax
	"answer the index of the max of all elements  "

	| max index |
	self isEmpty ifTrue: [^0].
	index := 1.
	max := self at: 1.
	2 to: self size
		do: 
			[:i | 
			| tmp |
			(tmp := self at: i) > max 
				ifTrue: 
					[max := tmp.
					index := i]].
	^index! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
findMaxOf: aBlock 
	"answer the index of the max of all elements after applying a Block"

	| max index |
	self isEmpty ifTrue: [^0].
	index := 1.
	max := aBlock value: (self at: 1).
	2 to: self size
		do: 
			[:i | 
			| tmp |
			(tmp := aBlock value: (self at: i)) > max 
				ifTrue: 
					[max := tmp.
					index := i]].
	^index! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
findMin
	| min index |
	self isEmpty ifTrue: [^0].
	index := 1.
	min := self at: 1.
	2 to: self size
		do: 
			[:i | 
			| tmp |
			(tmp := self at: i) < min 
				ifTrue: 
					[min := tmp.
					index := i]].
	^index! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
findMinOf: aBlock 
	"answer the index of the min of all elements after applying a Block"

	| min index |
	self isEmpty ifTrue: [^0].
	index := 1.
	min := aBlock value: (self at: 1).
	2 to: self size
		do: 
			[:i | 
			| tmp |
			(tmp := aBlock value: (self at: i)) < min 
				ifTrue: 
					[min := tmp.
					index := i]].
	^index! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
first
	^self at: 1! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
fromColumn: jStart toColumn: jStop by: jStep
	^self atColumns: (jStart to: jStop by: jStep)! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
fromRow: iStart toRow: iStop by: iStep
	^self atRows: (iStart to: iStop by: iStep)! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/20/2009 01:53'!
fromRow: irStart toRow: irStop fromColumn: jcStart toColumn: jcStop 
	"Extract a contiguous sub-matrix"

	| nr nc result |
	nr := irStop - irStart + 1.
	nc := jcStop - jcStart + 1.
	result := self class nrow: nr ncol: nc.
	result 
		copy: nr
		rowsStartingAt: irStart
		and: nc
		columnsStartingAt: jcStart
		from: self.
	^result! !

!AbstractMatrix methodsFor: 'generalized access' stamp: ''!
generalizedAt: index 
	^index indexAccessInto: self! !

!AbstractMatrix methodsFor: 'generalized access' stamp: ''!
generalizedAt: index put: anObject 
	^index indexAccessInto: self put: anObject! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
hasSameShapeAs: aMatrix
	^nrow = aMatrix nrow and: [ncol = aMatrix ncol]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
hasShape: nRows by: nColumns 
	^nrow = nRows and: [ncol = nColumns]! !

!AbstractMatrix methodsFor: 'comparing' stamp: ''!
hash
	"Answer a uniformly distributed SmallInteger computed from the contents 
	 of the receiver. This algorithm is congruent with String>stringhash. I.e. 
	 an Array of a sequence of characters has the same hash as a String of 
	 those same characters."

	| size |
	^0 = (size := self size)
		ifTrue: [12345]
		ifFalse: 
			[| midLeft midRight nextToLast firstc mlc mrc nlc lastc |
			size = 1
				ifTrue: [midLeft := midRight := nextToLast := 1]
				ifFalse: 
					[midLeft := size bitShift: -1.
					midRight := midLeft + 1.
					nextToLast := size - 1].
			firstc := (self at: 1) hash.
			mlc := (self at: midLeft) hash.
			mrc := (self at: midRight) hash.
			nlc := (self at: nextToLast) hash.
			lastc := (self at: size) hash.
			mrc
			+ (mrc + size bitShift: 8)
			+ ((firstc + nlc bitAnd: 16383) bitShift: 12)
			+ (nlc bitShift: 2)
			+ ((lastc bitAnd: 2047) bitShift: 16)
			+ (firstc + lastc bitShift: 4)
			+ ((mlc bitAnd: 255) bitShift: 20)
			+ (mlc bitShift: 6)]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
i
	^self collect: [:e | e i]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
i: aMatrix
	^self + aMatrix i! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
identity
	nrow = ncol ifFalse: [self error: 'should be square'].
	^self class eye: nrow! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
imaginaryPart
	^self collect: [:e | e imaginary]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
indicesCollect: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: 
					[:row | 
					res 
						rowAt: row
						columnAt: column
						put: (aBlock value: row value: column)]].
	^res! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
indicesDo: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	1 to: ncol
		do: [:column | 1 to: nrow do: [:row | aBlock value: row value: column]]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
indicesInject: start into: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	| current |
	current := start.
	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: 
					[:row | 
					current := aBlock 
								value: current
								value: row
								value: column]].
	^current! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
inject: aValue into: aBlock 
	| result |
	result := aValue.
	1 to: self size
		do: [:i | result := aBlock value: result value: (self at: i)].
	^result! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isColumnMatrix
	^ncol = 1! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isColumnVector
	^ncol = 1! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isComplexMatrix
	^self anySatisfy: [:e | e isComplex]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isDiagonal
	nrow = ncol ifFalse: [^false].
	^(1 to: ncol) 
		allSatisfy: [:j | (1 to: nrow) allSatisfy: [:i | i = j or: [(self rowAt: i columnAt: j) isZero]]]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isEmpty
	^self size = 0! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isHermitian
	nrow = ncol ifFalse: [^false].
	^self = self transposeConjugated! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isLowerTriangular
	nrow = ncol ifFalse: [^false].
	^(2 to: ncol) 
		allSatisfy: [:jc | (1 to: jc - 1) allSatisfy: [:ir | (self rowAt: ir columnAt: jc) isZero]]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isMatrix
	^true! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isRowMatrix
	^nrow = 1! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isRowVector
	^nrow = 1! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isSameSequenceAs: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's size, and each
	 of the receiver's elements equal the corresponding element of otherCollection."

	| size |
	(size := self size) = otherCollection size ifFalse: [^false].
	1 to: size do: [:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^false]].
	^true! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isSequenceable
	"I implement at: at:put: and size, this should be enough"

	^true! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isSquare
	^nrow = ncol! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isSymmetric
	nrow = ncol ifFalse: [^false].
	^self = self transposed! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isTriangular
	^self isLowerTriangular or: [self isUpperTriangular]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isUpperTriangular
	nrow = ncol ifFalse: [^false].
	^(2 to: nrow) 
		allSatisfy: [:ir | (1 to: ir - 1) allSatisfy: [:jc | (self rowAt: ir columnAt: jc) isZero]]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isVector
	^self isColumnVector or: [self isRowVector]! !

!AbstractMatrix methodsFor: 'testing' stamp: ''!
isZero
	^self allSatisfy: [:each | each isZero]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
last
	^self at: self size! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
lowerTriangle
	"return lower triangle matrix"

	^self lowerTriangle: 0! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
lowerTriangle: ind 
	"return lower triangle matrix starting with super-diagonal ind"

	| lower |
	lower := self copy.
	1 to: ncol
		do: 
			[:j | 
			1 to: nrow
				do: 
					[:i | 
					j - ind > i 
						ifTrue: 
							[lower 
								rowAt: i
								columnAt: j
								put: 0]]].
	^lower! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
max
	| max |
	max := self first.
	1 to: self size do: [:i | max := max max: (self at: i)].
	^max! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
maxOf: aBlock 
	| max |
	self isEmpty ifTrue: [^nil].
	max := aBlock value: (self at: 1).
	2 to: self size do: [:i | max := max max: (aBlock value: (self at: i))].
	^max! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
maxOf: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: 1.
			1 to: nrow
				do: 
					[:ir | 
					res at: ir
						put: ((1 to: ncol) 
								maxOf: [:jc | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: 1 ncol: ncol.
			1 to: ncol
				do: 
					[:jc | 
					res at: jc
						put: ((1 to: nrow) 
								maxOf: [:ir | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
min
	| min |
	min := self first.
	1 to: self size do: [:i | min := min min: (self at: i)].
	^min! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
minOf: aBlock 
	"answer the min of all elements after applying a Block"

	| min |
	self isEmpty ifTrue: [^nil].
	min := aBlock value: (self at: 1).
	2 to: self size do: [:i | min := min min: (aBlock value: (self at: i))].
	^min! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
minOf: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: 1.
			1 to: nrow
				do: 
					[:ir | 
					res at: ir
						put: ((1 to: ncol) 
								minOf: [:jc | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: 1 ncol: ncol.
			1 to: ncol
				do: 
					[:jc | 
					res at: jc
						put: ((1 to: nrow) 
								minOf: [:ir | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
nCols
	"Synonym Smallpack compatible"

	^ncol! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
nRows
	"Synonym Smallpack compatible"

	^nrow! !

!AbstractMatrix methodsFor: 'private' stamp: ''!
naiveSetOffDiagonal: alpha diagonal: beta 
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					self 
						rowAt: ir
						columnAt: jc
						put: (ir = jc ifTrue: [beta] ifFalse: [alpha])]]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
ncol
	^ncol! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
negated
	^self collect: [:e | e negated]! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
norm1
	^(1 to: ncol) 
		maxOf: [:jc | (1 to: nrow) sum: [:ir | (self rowAt: ir columnAt: jc) abs]]! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
norm2
	^self singularValues max! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
normFrobenius
	^self vectorNorm2! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
normInfinity
	^(1 to: nrow) 
		maxOf: [:ir | (1 to: ncol) sum: [:jc | (self rowAt: ir columnAt: jc) abs]]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
nrow
	^nrow! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
numberOfColumns
	^ncol! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
numberOfRows
	^nrow! !

!AbstractMatrix methodsFor: 'copying' stamp: ''!
postCopy
	array := array copy! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
prependColumns: nColumns 
	| res |
	res := self class nrow: nrow ncol: ncol + nColumns.
	res 
		copy: nrow
		rowsStartingAt: 1
		and: ncol
		columnsStartingAt: nColumns + 1
		from: self.
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
prependRows: nRows 
	| res |
	res := self class nrow: nrow + nRows ncol: ncol.
	res 
		copy: nrow
		rowsStartingAt: nRows + 1
		and: ncol
		columnsStartingAt: 1
		from: self.
	^res! !

!AbstractMatrix methodsFor: 'printing' stamp: ''!
printOn: aStream 
	aStream
		nextPut: $(;
		nextPutAll: self class name;
		space;
		nextPutAll: #rows:;
		space;
		nextPutAll: '#('.
	1 to: nrow
		do: 
			[:i | 
			aStream
				crtab;
				nextPutAll: '#('.
			1 to: ncol
				do: 
					[:j | 
					(self rowAt: i columnAt: j) printOn: aStream.
					aStream space].
			aStream nextPut: $)].
	aStream
		cr;
		nextPut: $);
		nextPut: $)! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
product
	| prod |
	self isEmpty ifTrue: [^1].
	prod := self at: 1.
	2 to: self size do: [:i | prod := prod * (self at: i)].
	^prod! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 8/2/2006 22:18'!
product: aBlock 
	^self productOf: aBlock! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productColumnVectorWithRowVector: aVector 
	"Vector * Vector :transpose
	naive algorithm"

	| result |
	result := self class allocateNrow: self size ncol: aVector size.
	1 to: aVector size
		do: 
			[:jc | 
			1 to: self size
				do: 
					[:ir | 
					result 
						rowAt: ir
						columnAt: jc
						put: (self at: ir) * (aVector at: jc)]].
	^result! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromComplex: aComplex 
	^self collect: [:each | aComplex * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromDouble: aDouble 
	^self collect: [:each | aDouble * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFixedPoint: aFixedPoint 
	^self collect: [:each | aFixedPoint * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFloat: aFloat 
	^self collect: [:each | aFloat * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFraction: aFraction 
	^self collect: [:each | aFraction * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromInteger: anInteger 
	^self collect: [:each | anInteger * each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromLapackMatrix: aLapackMatrix
	^self productFromMatrix: aLapackMatrix asGeneralMatrix! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
productFromMatrix: aMatrix 
	"Algorithm ^(aMatrix productMatrixWithMatrix: self)
	is general and would work well.
	But individual methods might be optimized in subclasses"

	aMatrix ncol = nrow 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	^self isColumnVector 
		ifTrue: 
			[aMatrix isRowVector 
				ifTrue: [aMatrix productRowVectorWithColumnVector: self]
				ifFalse: [aMatrix productMatrixWithColumnVector: self]]
		ifFalse: 
			[aMatrix isColumnVector 
				ifTrue: [aMatrix productColumnVectorWithRowVector: self]
				ifFalse: 
					[aMatrix isRowVector 
						ifTrue: [aMatrix productRowVectorWithMatrix: self]
						ifFalse: [aMatrix productMatrixWithMatrix: self]]]! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixAtRightWithMatrix: aMatrix 
	"Answer the matrix product
		aMatrix * self
	This can be optimized in special cases of hermitian or triangular Matrix
	and should be overloaded in these subclasses"

	^aMatrix productMatrixWithMatrix: self! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 6/27/2006 17:06'!
productMatrixTransposeWithColumnVector: aVector 
	"Matrix transpose * vector
	naive algorithm"

	| result |
	result := self class allocateNrow: ncol ncol: 1.
	1 to: ncol
		do: 
			[:jc | 
			result at: jc
				put: ((1 to: nrow) 
						sum: [:ir | (self rowAt: ir columnAt: jc) * (aVector at: ir)])].
	^result! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixWithColumnVector: aVector 
	"Matrix * vector
	naive algorithm"

	| result |
	result := self class allocateNrow: nrow ncol: 1.
	1 to: nrow
		do: 
			[:ir | 
			result at: ir
				put: ((1 to: ncol) 
						sum: [:jc | (self rowAt: ir columnAt: jc) * (aVector at: jc)])].
	^result! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixWithMatrix: aMatrix 
	| a b c iA iB iC |
	a := self.
	b := aMatrix.
	c := aMatrix class allocateNrow: a nrow ncol: b ncol.
	iC := 0.
	iB := 1.
	1 to: b ncol
		do: 
			[:jc | 
			iA := 1.
			1 to: a nrow
				do: 
					[:ir | 
					| cij kA kB |
					cij := (a at: (kA := iA)) * (b at: (kB := iB)).
					2 to: b nrow
						do: [:k | cij := cij + ((a at: (kA := kA + a nrow)) * (b at: (kB := kB + 1)))].
					c at: (iC := iC + 1) put: cij.
					iA := iA + 1].
			iB := iB + b nrow].
	^c! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 8/2/2006 22:18'!
productOf: aBlock 
	| product |
	self isEmpty ifTrue: [^1].
	product := aBlock value: (self at: 1).
	2 to: self size
		do: [:i | product := product * (aBlock value: (self at: i))].
	^product! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 8/2/2006 22:18'!
productOf: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: 1.
			1 to: nrow
				do: 
					[:ir | 
					res at: ir
						put: ((1 to: ncol) 
								product: [:jc | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: 1 ncol: ncol.
			1 to: ncol
				do: 
					[:jc | 
					res at: jc
						put: ((1 to: nrow) 
								product: [:ir | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productRowVectorWithColumnVector: aVector 
	"Answer the result of operation (a dot product)
		leftVector transpose * aVector
	where
		leftVector transpose = self"

	| res |
	res := self class allocateNrow: 1 ncol: 1.
	res at: 1
		put: ((1 to: self size) sum: [:i | (self at: i) * (aVector at: i)]).
	^res! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
productRowVectorWithMatrix: aMatrix 
	"Vector * Matrix
	naive algorithm"

	| result |
	result := self class allocateNrow: 1 ncol: aMatrix ncol.
	1 to: aMatrix ncol
		do: 
			[:jc | 
			result at: jc
				put: ((1 to: aMatrix nrow) 
						sum: [:ir | (self at: ir) * (aMatrix rowAt: ir columnAt: jc)])].
	^result! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
realPart
	^self collect: [:e | e real]! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 8/31/2011 23:27'!
replicate: newDimensions
	^self class shape: newDimensions do: [:nr :nc | self replicateNrow: nr timesNcol: nc]! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
replicateNrow: nr timesNcol: nc 
	"build a Matrix by replicating self in rows and in columns
	Analogous to Matlab repmat"

	| res |
	res := self class allocateNrow: nrow * nr ncol: ncol * nc.
	1 to: nc
		do: 
			[:jc | 
			1 to: nr
				do: 
					[:ir | 
					res 
						copy: nrow rowsStartingAt: (ir - 1) * nrow + 1
						and: ncol columnsStartingAt: (jc - 1) * ncol + 1
						from: self]].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 8/31/2011 23:25'!
reshape: newDimensions
	^self class shape: newDimensions do: [:nr :nc | self reshapeNrow: nr ncol: nc]! !

!AbstractMatrix methodsFor: 'converting' stamp: 'nice 8/31/2011 23:24'!
reshapeNrow: nr ncol: nc
	nrow * ncol = (nr * nc) ifFalse: [self error: 'cannot reshape with a different size'].
	^(nrow = nr and: [ncol = nc])
		ifTrue: [self]
		ifFalse: 
			[| res |
			res := self class nrow: nr ncol: nc.
			1 to: self size do: [:i | res at: i put: (self at: i)].
			res]! !

!AbstractMatrix methodsFor: 'testing' stamp: 'nice 5/20/2006 02:24'!
respondsToArithmetic
	^true! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
rowAt: rowIndex 
	^(self 
		atIntervalFrom: rowIndex
		to: (ncol - 1) * nrow + rowIndex
		by: nrow) asRowMatrix! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
rowAt: rowIndex columnAt: columnIndex 
	"Access the underlying array"

	^self at: (columnIndex - 1) * nrow + rowIndex! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
rowAt: rowIndex columnAt: columnIndex  put: aNumber
	"Access the underlying array"

	^self at: (columnIndex - 1) * nrow + rowIndex put: aNumber! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
rowAt: rowIndex putAll: aNumber 
	1 to: ncol
		do: 
			[:each | 
			self 
				rowAt: rowIndex
				columnAt: each
				put: aNumber]! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
rowAt: rowIndex putSequence: aCollection 
	1 to: aCollection size
		do: 
			[:each | 
			self 
				rowAt: rowIndex
				columnAt: each
				put: (aCollection at: each)]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
rowCount
	"Squeak compatible"

	^nrow! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
rows
	^(1 to: nrow) collect: [:rowIndex | self rowAt: rowIndex]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
rows: anArrayOfRows 
	1 to: anArrayOfRows size
		do: [:rowIndex | self rowAt: rowIndex putSequence: (anArrayOfRows at: rowIndex)]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
rowsDo: aBlock 
	"evaluate aBlock with each row"

	1 to: nrow do: [:i | aBlock value: (self rowAt: i)]! !

!AbstractMatrix methodsFor: 'private-blas' stamp: ''!
scale: n elementsBy: alpha increment: incx 
	"BLAS primitve xSCAL - naive implementation"

	| sx |
	sx := incx positive ifTrue: [1] ifFalse: [(1 - n) * incx + 1].
	1 to: n
		do: 
			[:i | 
			self at: (i - 1) * incx + sx
				put: (self at: (i - 1) * incx + sx) * alpha]! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 2/16/2006 04:19'!
scaledByComplex: aComplex 
	"Answer a copy of self scaled."

	aComplex imaginary isZero ifTrue: [^self scaledByNumber: aComplex real].
	^self collect: [:each | each * aComplex]! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: 'nice 2/16/2006 04:20'!
scaledByNumber: aNumber 
	"Answer a copy of self scaled."

	^self collect: [:each | each * aNumber]! !

!AbstractMatrix methodsFor: 'initialize-release' stamp: ''!
setArray: anArray nrow: nr ncol: nc 
	array := anArray.
	nrow := nr.
	ncol := nc! !

!AbstractMatrix methodsFor: 'initialize-release' stamp: ''!
setDiagonal: aMatrix
	"set the diagonal elements"

	1 to: aMatrix size do: [:i | self rowAt: i columnAt: i put: (aMatrix at: i)].! !

!AbstractMatrix methodsFor: 'initialize-release' stamp: ''!
setOffDiagonal: alpha diagonal: beta 
	self atAllPut: alpha.
	1 to: (nrow min: ncol)
		do: 
			[:i | 
			self 
				rowAt: i
				columnAt: i
				put: beta]! !

!AbstractMatrix methodsFor: 'initialize-release' stamp: ''!
setToEye
	"Initialize diagonal to 1, off diagonal to 0"

	self setOffDiagonal: 0 diagonal: 1! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
size
	^self capacity! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 12:26'!
smallLowerTriangle: ind 
	"return small lower triangle matrix starting with super-diagonal ind"

	| lower |
	ind <= 0
		ifTrue: [
			lower := self class nrow: (nrow + ind max: 0) ncol: (ncol min: (nrow + ind max: 0)).
			1 to: lower ncol
				do: 
					[:j | 
					1 to: lower nrow
						do: 
							[:i | 
							j <= i 
								ifTrue: 
									[lower 
										rowAt: i
										columnAt: j
										put: (self rowAt: i - ind columnAt: j)]]]]
		ifFalse: [
			lower := self class nrow: nrow ncol: (ncol min: nrow + ind).
			1 to: lower ncol
				do: 
					[:j | 
					1 to: lower nrow
						do: 
							[:i | 
							j - ind <= i 
								ifTrue: 
									[lower 
										rowAt: i
										columnAt: j
										put: (self rowAt: i columnAt: j)]]]].
	^lower	! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 12:26'!
smallUpperTriangle: ind 
	"return small upper triangle matrix starting with super-diagonal ind"

	| upper |
	ind >= 0
		ifTrue: [
			upper := self class nrow: (nrow min: (ncol - ind max: 0)) ncol: (ncol - ind max: 0).
			1 to: upper ncol
				do: 
					[:j | 
					1 to: upper nrow
						do: 
							[:i | 
							j >= i 
								ifTrue: 
									[upper 
										rowAt: i
										columnAt: j
										put: (self rowAt: i columnAt: j + ind)]]]]
		ifFalse: [
			upper := self class nrow: (nrow min: ncol - ind) ncol: ncol.
			1 to: upper ncol
				do: 
					[:j | 
					1 to: upper nrow
						do: 
							[:i | 
							j - ind >= i 
								ifTrue: 
									[upper 
										rowAt: i
										columnAt: j
										put: (self rowAt: i columnAt: j)]]]].
	^upper	! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
sum
	| sum |
	self isEmpty ifTrue: [^0].
	sum := self at: 1.
	2 to: self size do: [:i | sum := sum + (self at: i)].
	^sum! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
sum: aBlock 
	| sum |
	self isEmpty ifTrue: [^0].
	sum := aBlock value: (self at: 1).
	2 to: self size do: [:i | sum := sum + (aBlock value: (self at: i))].
	^sum! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromComplex: aComplex 
	^self collect: [:each | aComplex + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromDouble: aDouble 
	^self collect: [:each | aDouble + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromFixedPoint: aFixedPoint 
	^self collect: [:each | aFixedPoint + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromFloat: aFloat 
	^self collect: [:each | aFloat + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromFraction: aFraction 
	^self collect: [:each | aFraction + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromInteger: anInteger 
	^self collect: [:each | anInteger + each]! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromLapackMatrix: aLapackMatrix
	^self sumFromMatrix: aLapackMatrix asGeneralMatrix! !

!AbstractMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromMatrix: aMatrix 
	| res |
	(nrow = aMatrix nrow and: [ncol = aMatrix ncol]) 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: self size
		do: [:i | res at: i put: (aMatrix at: i) + (self at: i)].
	^res! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 8/2/2006 22:17'!
sumOf: aBlock 
	^self sumOf: aBlock! !

!AbstractMatrix methodsFor: 'enumerating' stamp: 'nice 8/2/2006 22:17'!
sumOf: aBlock dimension: aDimension 
	| res |
	aDimension = 2 
		ifTrue: 
			[res := self class allocateNrow: nrow ncol: 1.
			1 to: nrow
				do: 
					[:ir | 
					res at: ir
						put: ((1 to: ncol) 
								sum: [:jc | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	aDimension = 1 
		ifTrue: 
			[res := self class allocateNrow: 1 ncol: ncol.
			1 to: ncol
				do: 
					[:jc | 
					res at: jc
						put: ((1 to: nrow) 
								sum: [:ir | aBlock value: (self rowAt: ir columnAt: jc)])].
			^res].
	self error: 'UNKNOWN DIMENSION : should be 1 or 2'.
	^nil! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
swap: r1 at: c1 with: r2 at: c2 
	"Squeak compatible protocol"

	^self swapRowAt: r1 columnAt: c1 withRowAt: r2 columnAt: c2! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
swapColumn: c1 withColumn: c2
	"Squeak compatible - avoid direct access to array because subclasses might implement other behaviour
	NAIVE implementation"

	1 to: nrow do: [:row |
		self swapRowAt: row columnAt: c1 withRowAt: row columnAt: c2]! !

!AbstractMatrix methodsFor: 'accessing' stamp: ''!
swapRow: r1 withRow: r2
	"Squeak compatible - avoid direct access to array because subclasses might implement other behaviour
	NAIVE implementation"

	1 to: ncol do: [:col |
		self swapRowAt: r1 columnAt: col withRowAt: r2 columnAt: col]! !

!AbstractMatrix methodsFor: 'accessing' stamp: 'nice 2/3/2012 14:00'!
swapRowAt: r1 columnAt: c1 withRowAt: r2 columnAt: c2 
	"Swap two elements.
	Avoid direct access to array because subclasses might implement other behaviour"

	| tmp |
	tmp := self at: r1 at: c1.
	self 
		at: r1
		at: c1
		put: (self at: r2 at: c2).
	self 
		at: r2
		at: c2
		put: tmp! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
transpose
	"synonym"

	^self transposed! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
transposeConjugated
	"naive un-optimized algorithm"

	| res |
	self isRowMatrix ifTrue: [^self asColumnMatrix conjugated].
	self isColumnMatrix ifTrue: [^self asRowMatrix conjugated].
	res := self class allocateNrow: ncol ncol: nrow.
	1 to: ncol
		do: 
			[:j | 
			1 to: nrow
				do: 
					[:i | 
					res 
						rowAt: j
						columnAt: i
						put: (self rowAt: i columnAt: j) conjugated]].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
transposed
	"naive un-optimized algorithm"

	| res |
	self isRowMatrix ifTrue: [^self asColumnMatrix].
	self isColumnMatrix ifTrue: [^self asRowMatrix].
	res := self class allocateNrow: ncol ncol: nrow.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: jc
						columnAt: ir
						put: (self rowAt: ir columnAt: jc)]].
	^res! !

!AbstractMatrix methodsFor: 'converting' stamp: ''!
transposedConjugated
	"Synonym"

	^self transposeConjugated! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
upperTriangle
	"return upper triangle matrix"

	^self upperTriangle: 0! !

!AbstractMatrix methodsFor: 'accessing-submatrix' stamp: ''!
upperTriangle: ind 
	"return upper triangle matrix starting with super-diagonal ind"

	| upper |
	upper := self copy.
	1 to: ncol
		do: 
			[:j | 
			1 to: nrow
				do: 
					[:i | 
					j - ind < i 
						ifTrue: 
							[upper 
								rowAt: i
								columnAt: j
								put: 0]]].
	^upper! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
vectorNorm1
	^self sum: [:e | e abs]! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
vectorNorm2
	"Naive algorithm - not protected against underflow/overflow"

	^(self sum: [:e | e abs squared]) sqrt! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
vectorNormFrobenius
	^self vectorNorm2! !

!AbstractMatrix methodsFor: 'norm' stamp: ''!
vectorNormInfinity
	^self maxOf: [:e | e abs]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
with: aCollection collect: aBlock 
	"aCollection must support #at:at: and be at least as large as the receiver.
	Squeak compatible message"

	^self withIndicesCollect: 
			[:each :row :column | 
			aBlock value: each value: (aCollection at: row at: column)]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
with: aCollection do: aBlock 
	"aCollection must support #at:at: and be at least as large as the receiver.
	Squeak compatible message"

	self 
		withIndicesDo: [:each :row :column | aBlock value: each value: (aCollection at: row at: column)]! !

!AbstractMatrix methodsFor: 'private' stamp: ''!
withArrayOffsetBy: aPositiveInteger 
	"Return a kind of shallow copy of self pointing on the same array object, but with an offset.
	This is ugly like C code but maybe more efficient"

	^self class basicNew 
		setArray: (array reindexedThrough: (aPositiveInteger + 1 to: self size))
		nrow: self size - aPositiveInteger
		ncol: 1! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
withIndicesCollect: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	| res |
	res := self class allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: 
					[:row | 
					res 
						rowAt: row
						columnAt: column
						put: (aBlock 
								value: (self rowAt: row columnAt: column)
								value: row
								value: column)]].
	^res! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
withIndicesDo: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: 
					[:row | 
					aBlock 
						value: (self rowAt: row columnAt: column)
						value: row
						value: column]]! !

!AbstractMatrix methodsFor: 'enumerating' stamp: ''!
withIndicesInject: start into: aBlock 
	"Squeak compatible message
	BEWARE this is column-major ordered"

	| current |
	current := start.
	1 to: ncol
		do: 
			[:column | 
			1 to: nrow
				do: 
					[:row | 
					"NOT EFFICIENT AT ALL... CREATE AN ARRAY AT EACH STEP
					SHOULD CONSIDER ADDING value:value:value:value: EXTENSION IN VW"
					current := aBlock valueWithArguments: (Array 
										with: current
										with: (self rowAt: row columnAt: column)
										with: row
										with: column)]].
	^current! !

!AbstractMatrix methodsFor: 'arithmetic' stamp: ''!
zero
	^self class nrow: nrow ncol: ncol! !

AbstractMatrix subclass: #LapackMatrix
	instanceVariableNames: ''
	classVariableNames: 'ArrayInterfaces BandStorageMask BlasInterfaces BothUpperLowerMask CArrayClasses ComplexMask ComplexityMask DefaultSeedArray DiagonalMask DoublePrecisionMask FlagsToClassDictionary FullStorageMask GeneralMask HermitianMask LapackInterfaces LowerMask PackedStorageMask PrecisionMask PropertyMask RealMask SDCZMask SinglePrecisionMask SmalltalkArrayClasses StorageMask TriangularMask UpperMask UseCBlas UseCLapack'
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

LapackMatrix class
	instanceVariableNames: 'libraryErrorCollection smalltalkAccessError cAccessError flags'!

!LapackMatrix commentStamp: '<historical>' prior: 0!
LapackMatrix can use special CArrayAccessor operating on an underlying CPointer in place of regular array.
This is in order to access fast external libraries (BLAS LAPACK)

In order to survive through image snapshots, array can also be stored in the Smalltalk space (a RawArray) .
Commutations of arrays are done through protocol #cArray, #storeInSmalltalkSpace.
There is a small risk in multi-process that the Matrix no more point to its array (if snapshot occurs at critical point).

Flags for handling generallity and coercing :
We want to be able to add or multiply a double complex hermitian matrix with a triangular single precision real matrix.
Double dispatching is not the right solution due to numerous subclasses involved !!
Generality is not well fitted either, because there are 4 fields of generality :
	Precision (double , single)
	Complexity (complex , real)
	Property (general , triangular , hermitian)
	Storage (dense, packed , banded)

Solution is to use bit flags for each field.
The more general class has flags set to 1, the less general has flags set to 0.
For property, this is less clear because adding a triangular and a hermitian should result in general matrices...
The flags are arranged so that they should be bitOr:'ed to get flags of resulting class for most operations...

The flags are cached in a class instance variable. Current implementation is:
	bit 0: floating point precision (single=0 double=1)
	bit 1: complexity (real=0 complex=1)
	bit 2,3,4 : property (general=111 triangular=101 hermitian=011) there is room for 110...
	bit 5,6: storage (11=full 10=band 01=packed) 00 not attributed... room for tri-diagonal?

External DLL functions of BLAS/LAPACK library are called for performing arithmetic and algebra algorithm.
For instance, the blas function to copy a vector times a scalar is named AXPY.
Depending on the precision and complexity, either the CAXPY, DAXPY, SAXPY or ZAXPY function must be called.
These functions take the same arguments.
So an easy way to factor code is to create 4 subclasses of the blas library, one for each precision/complexity pair.
Then, the correct subclass must be used depending on Matrix class.
This is implemented by caching the interfaces into a shared variable accessed with #sdczIndex indirection.

Another possibility is to call CBLAS, a version of BLAS with C-like interface (passing values instead of pointers).
If one changes the Settings (using CBLAS or not), then the (LapackMatrix resetBlasInterfaces) must be called.

Some Exception can occur in case one try to store a Double into a SinglePrecisionMatrix.
Some other if a library is not found.
These exceptions are protected with exception handling.
The class of these exceptions are cached into some class instance variable for efficiency.
!

LapackMatrix class
	instanceVariableNames: 'libraryErrorCollection smalltalkAccessError cAccessError flags'!

LapackMatrix subclass: #LapackDiagonalMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackDiagonalMatrix commentStamp: '<historical>' prior: 0!
LapackDiagonalMatrix is square and has zeroes off diagonal by definition.

It stores only diagonal elements in the array (economic).
!

LapackDiagonalMatrix subclass: #LapackCDIMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackCDIMatrix commentStamp: '<historical>' prior: 0!
LapackCDIMatrix handles Diagonal Matrices composed of single precision complex numbers.
See superclass for more information.!

!LapackCDIMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackCDIMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: DiagonalMask) 
				bitOr: (ComplexMask bitOr: SinglePrecisionMask)! !

LapackDiagonalMatrix subclass: #LapackDDIMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackDDIMatrix commentStamp: '<historical>' prior: 0!
LapackDDIMatrix handles Diagonal Matrices composed of double precision real numbers.
See superclass for more information.!

!LapackDDIMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackDDIMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: DiagonalMask) 
				bitOr: (RealMask bitOr: DoublePrecisionMask)! !

!LapackDiagonalMatrix class methodsFor: 'private' stamp: ''!
allocateNrow: nr ncol: nc 
	"Only allocate storage for the diagonal.
	A diagonal matrix should be squared"

	nr = nc ifFalse: [^self generalMatrix allocateNrow: nr ncol: nc].
	^self basicNew 
		setArray: (Array new: nr)
		nrow: nr
		ncol: nc! !

!LapackDiagonalMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger 
	"prefer double index accessing"

	| ir ic |
	ir := (anInteger - 1) \\ nrow + 1.
	ic := (anInteger - 1) // nrow + 1.
	^self rowAt: ir columnAt: ic! !

!LapackDiagonalMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger put: aNumber 
	"prefer double index accessing"

	| ir ic |
	ir := (anInteger - 1) \\ nrow + 1.
	ic := (anInteger - 1) // nrow + 1.
	^self 
		rowAt: ir
		columnAt: ic
		put: aNumber! !

!LapackDiagonalMatrix methodsFor: 'accessing-submatrix' stamp: ''!
columnAt: columnIndex 
	| column |
	column := self class generalMatrix nrow: nrow ncol: 1.
	column at: columnIndex put: (self arrayAt: columnIndex).
	^column! !

!LapackDiagonalMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	^index = 0 
		ifTrue: [self castToColumn copy]
		ifFalse: [self class generalMatrix nrow: (self diagonalSizeAt: index)]! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
differenceWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class"

	| res |
	res := self copy.
	res castToColumn 
		fill: self arraySize
		elementsWithStride: 1
		withSelfPlusScalar: -1
		timesVector: aLapackMatrix castToColumn
		stride: 1.
	^res! !

!LapackDiagonalMatrix methodsFor: 'decomposition' stamp: ''!
eigenValueDecomposition
	^LapackDiagonalEigenDecomposition decompose: self! !

!LapackDiagonalMatrix methodsFor: 'decomposition' stamp: ''!
eigenValues
	^self diagonal! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
elementwiseProductWithMatrix: aMatrix 
	^(self copy)
		setDiagonal: (self castToColumn 
					elementwiseProductWithMatrix: aMatrix diagonal);
		yourself! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
inPlaceScaledByComplex: aComplex 
	"only scale diagonal..."

	self castToColumn inPlaceScaledByComplex: aComplex! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
inPlaceScaledByNumber: aNumber 
	"only scale diagonal..."

	self castToColumn inPlaceScaledByNumber: aNumber! !

!LapackDiagonalMatrix methodsFor: 'testing' stamp: ''!
isDiagonal
	^true! !

!LapackDiagonalMatrix methodsFor: 'testing' stamp: ''!
isHermitian
	^self diagonal imaginaryPart isZero! !

!LapackDiagonalMatrix methodsFor: 'testing' stamp: ''!
isLowerTriangular
	^true! !

!LapackDiagonalMatrix methodsFor: 'testing' stamp: ''!
isSymmetric
	^true! !

!LapackDiagonalMatrix methodsFor: 'testing' stamp: ''!
isUpperTriangular
	^true! !

!LapackDiagonalMatrix methodsFor: 'accessing-submatrix' stamp: ''!
lowerTriangle: ind 
	"return lower triangle matrix"

	^ind >= 0 ifTrue: [self] ifFalse: [self class nrow: nrow ncol: ncol]! !

!LapackDiagonalMatrix methodsFor: 'decomposition' stamp: ''!
pluDecomposition
	^LapackDiagonalPLUdecomposition decompose: self! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixTransposeWithColumnVector: aLapackMatrix 
	"Product Matrix transposed*vector"

	^self productMatrixWithColumnVector: aLapackMatrix! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixWithColumnVector: aLapackMatrix 
	"Product Matrix * vector"

	^self castToColumn elementwiseProductWithMatrix: aLapackMatrix! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
reciprocal
	^self class diagonal: (array collect: [:each | each reciprocal])! !

!LapackDiagonalMatrix methodsFor: 'accessing-submatrix' stamp: ''!
rowAt: rowIndex 
	| row |
	row := self class generalMatrix nrow: 1 ncol: ncol.
	row at: rowIndex put: (self arrayAt: rowIndex).
	^row! !

!LapackDiagonalMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j 
	^i = j ifTrue: [self arrayAt: i] ifFalse: [0]! !

!LapackDiagonalMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j put: aNumber 
	^i = j 
		ifTrue: [self arrayAt: i put: aNumber]
		ifFalse: 
			[aNumber isZero 
				ifTrue: 
					["do nothing, only diagonal is stored"

					]
				ifFalse: 
					[| coerced |
					coerced := self class generalMatrix diagonal: self diagonal.
					coerced 
						rowAt: i
						columnAt: j
						put: aNumber.
					self become: coerced.
					aNumber]]! !

!LapackDiagonalMatrix methodsFor: 'arithmetic' stamp: ''!
sumWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class"

	| res |
	res := self copy.
	res castToColumn 
		fill: self arraySize
		elementsWithStride: 1
		withSelfPlusScalar: 1
		timesVector: aLapackMatrix castToColumn
		stride: 1.
	^res! !

!LapackDiagonalMatrix methodsFor: 'converting' stamp: 'nice 8/28/2011 21:35'!
transposed
	^self! !

!LapackDiagonalMatrix methodsFor: 'accessing-submatrix' stamp: ''!
upperTriangle: ind 
	"return upper triangle matrix"

	^ind <= 0 ifTrue: [self] ifFalse: [self class nrow: nrow ncol: ncol]! !

LapackDiagonalMatrix subclass: #LapackSDIMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackSDIMatrix commentStamp: '<historical>' prior: 0!
LapackSDIMatrix handles Diagonal Matrices composed of single precision real numbers.
See superclass for more information.!

!LapackSDIMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackSDIMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: DiagonalMask) 
				bitOr: (RealMask bitOr: SinglePrecisionMask)! !

LapackDiagonalMatrix subclass: #LapackZDIMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackZDIMatrix commentStamp: '<historical>' prior: 0!
LapackZDIMatrix handles Diagonal Matrices composed of double precision complex numbers.
See superclass for more information.!

!LapackZDIMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackZDIMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: DiagonalMask) 
				bitOr: (ComplexMask bitOr: DoublePrecisionMask)! !

LapackMatrix subclass: #LapackGeneralMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackGeneralMatrix commentStamp: '<historical>' prior: 0!
LapackGeneralMatrix is an abstract class for matrices having no known peculiar property,
as opposed to symmetric, hermitian, triangular or diagonal matrices.
As such, they use a dense storage scheme (elements in contiguous memory stored columnwise).

Subclasses are specialized for containing either real or complex numbers with a specific floating point format.!

LapackGeneralMatrix subclass: #LapackCGEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackCGEMatrix commentStamp: '<historical>' prior: 0!
LapackCGEMatrix handles General Matrices (dense storage) composed of single precision complex numbers
See superclass for more information.!

!LapackCGEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackCGEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: GeneralMask) 
				bitOr: (ComplexMask bitOr: SinglePrecisionMask)! !

!LapackCGEMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFloat: aFloat 
	"FAST: avoid super dispatching technique"

	^self scaledByNumber: aFloat! !

!LapackCGEMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:18'!
scale: n elementsBy: alpha increment: incx 
	
	[| comp |
	comp := alpha asFloatComplex.
	comp imaginary isZero 
		ifTrue: 
			[self blasInterface 
				realScalWithN: n
				alpha: comp real
				X: self arrayPointer
				incX: incx]
		ifFalse: 
			[self blasInterface 
				scalWithN: n
				alpha: comp
				X: self arrayPointer
				incX: incx]] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							scale: n
							elementsBy: alpha
							increment: incx)]! !

LapackGeneralMatrix subclass: #LapackDGEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackDGEMatrix commentStamp: '<historical>' prior: 0!
LapackDGEMatrix handles General Matrices (dense storage) composed of double precision real numbers
See superclass for more information.!

!LapackDGEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackDGEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags :=  (FullStorageMask bitOr: GeneralMask) 
				bitOr: (RealMask bitOr: DoublePrecisionMask)! !

!LapackDGEMatrix methodsFor: 'double dispatching' stamp: ''!
productFromDouble: aDouble 
	"FAST: avoid super dispatching technique"

	^self scaledByNumber: aDouble! !

!LapackDGEMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:18'!
scale: n elementsBy: alpha increment: incx 
	
	[self blasInterface 
		scalWithN: n
		alpha: alpha asFloat
		X: self arrayPointer
		incX: incx] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							scale: n
							elementsBy: alpha
							increment: incx)]! !

!LapackGeneralMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:19'!
absMax
	^
	[self lapackInterface 
		langeWithnorm: self lapackInterface maxAbs
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super absMax]! !

!LapackGeneralMatrix methodsFor: 'converting' stamp: ''!
coerceToGeneralMatrix
	^self! !

!LapackGeneralMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	| diag |
	diag := self class nrow: (self diagonalSizeAt: index).
	index >= 0 
		ifTrue: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index * nrow
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1]
		ifFalse: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index negated
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1].
	^diag! !

!LapackGeneralMatrix methodsFor: 'decomposition' stamp: ''!
eigenValueDecomposition
	^self isRealMatrix 
		ifTrue: [LapackRealEigenDecomposition decompose: self]
		ifFalse: [LapackComplexEigenDecomposition decompose: self]! !

!LapackGeneralMatrix methodsFor: 'decomposition' stamp: ''!
eigenValues
	"it's safer to get them by Schur algorithm"

	^(self schurDecomposition)
		wantVectors: false;
		eigenValues! !

!LapackGeneralMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:19'!
fill: m elementsWithStride: incy withSelfScaledBy: beta plusScalar: alpha timesMatrix: a transposed: trans timesVector: x length: n stride: incx 
	"fill self with a Matrix*Vector product
		alpha*op(a)*x+beta*self
	this is BLAS xGEMV operation"

	
	[self blasInterface 
		gemvWithTransA: (trans 
				ifTrue: [self blasInterface transposed]
				ifFalse: [self blasInterface notTransposed])
		M: m
		N: n
		alpha: alpha
		A: a arrayPointer
		lda: a nrow
		X: x arrayPointer
		incX: incx
		beta: beta
		Y: self arrayPointer
		incY: incy] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							fill: m
							elementsWithStride: incy
							withSelfScaledBy: beta
							plusScalar: alpha
							timesMatrix: a
							transposed: trans
							timesVector: x
							length: n
							stride: incx)]! !

!LapackGeneralMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:19'!
fillM: m byN: n withSelfScaledBy: beta plusScalar: alpha timesLeftMatrix: a transposed: transa timesRightMatrix: b transposed: transb length: k 
	"fill self with a Matrix*Matrix product
		alpha*transa(a)*transb(b)+beta*self
	this is BLAS xGEMM operation"

	
	[self blasInterface 
		gemmWithTransA: (transa 
				ifTrue: [self blasInterface transposed]
				ifFalse: [self blasInterface notTransposed])
		TransB: (transb 
				ifTrue: [self blasInterface transposed]
				ifFalse: [self blasInterface notTransposed])
		M: m
		N: n
		K: k
		alpha: alpha
		A: a arrayPointer
		lda: a nrow
		B: b arrayPointer
		ldb: b nrow
		beta: beta
		C: self arrayPointer
		ldc: self nrow] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							fillM: m
							byN: n
							withSelfScaledBy: beta
							plusScalar: alpha
							timesLeftMatrix: a
							transposed: transa
							timesRightMatrix: b
							transposed: transb
							length: k)]! !

!LapackGeneralMatrix methodsFor: 'decomposition' stamp: 'nice 2/20/2009 02:21'!
generalizedEigenValueDecompositionWithRHSMatrix: aLapackMatrix 
	"solve a generalized eigen value problem"

	^aLapackMatrix coercingFromLapackMatrix: self
		do: 
			[:a :b | 
			(a isRealMatrix 
				ifTrue: [LapackRealGeneralizedEigenDecomposition]
				ifFalse: [LapackComplexGeneralizedEigenDecomposition])
					decomposeLeft: a right: b]! !

!LapackGeneralMatrix methodsFor: 'converting' stamp: ''!
i
	| res |
	res := self class complexMatrix nrow: nrow ncol: ncol.
	^self class isComplexMatrix 
		ifTrue: 
			[| selfReal selfImag resReal resImag |
			selfReal := self castToRealWithArrayOffsetBy: 0.
			selfImag := self castToRealWithArrayOffsetBy: 1.
			resReal := res castToRealWithArrayOffsetBy: 0.
			resImag := res castToRealWithArrayOffsetBy: 1.
			resImag 
				copy: self arraySize
				elementsFrom: selfReal
				sourceIncrement: 2
				destIncrement: 2.
			resReal 
				copy: self arraySize
				elementsFrom: selfImag
				sourceIncrement: 2
				destIncrement: 2.
			resReal 
				scale: self arraySize
				elementsBy: -1
				increment: 2.
			res]
		ifFalse: 
			[(res castToRealWithArrayOffsetBy: 1) 
				copy: self arraySize
				elementsFrom: self
				sourceIncrement: 1
				destIncrement: 2.
			res]! !

!LapackGeneralMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 22:43'!
lowerTriangle: ind 
	"return lower triangle matrix"

	^
	[ind <= 0 
		ifTrue: 
			[| b offset |
			b := self class triangularMatrix nrow: nrow ncol: ncol.
			offset := ind negated.
			b beLower.
			self lapackInterface 
				lacpyWithuplo: self lapackInterface lower
				m: b nrow - offset
				n: (b nrow - offset min: b ncol)
				a: (self arrayPointerWithOffset: offset)
				lda: nrow
				b: (b arrayPointerWithOffset: offset)
				ldb: b nrow.
			b]
		ifFalse: 
			[| b offset |
			offset := (ind + 1) * nrow.
			b := self copy.
			b lapackInterface 
				lasetWithuplo: b lapackInterface upper
				m: (b ncol - ind - 1 min: b nrow)
				n: b ncol - ind - 1
				alpha: 0.0
				beta: 0.0
				a: (b arrayPointerWithOffset: offset)
				lda: b nrow.
			b]] 
			on: Error
			do: [:exc | exc return: (super lowerTriangle: ind)]! !

!LapackGeneralMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:20'!
norm1
	^
	[self lapackInterface 
		langeWithnorm: self lapackInterface norm1
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super norm1]! !

!LapackGeneralMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:20'!
normFrobenius
	^
	[self lapackInterface 
		langeWithnorm: self lapackInterface normF
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super normFrobenius]! !

!LapackGeneralMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:20'!
normInfinity
	^
	[self lapackInterface 
		langeWithnorm: self lapackInterface normI
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super normInfinity]! !

!LapackGeneralMatrix methodsFor: 'decomposition' stamp: ''!
pluDecomposition
	^LapackPLUdecomposition decompose: self! !

!LapackGeneralMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:20'!
productMatrixTransposeWithColumnVector: aLapackMatrix 
	"Product Matrix transpose * vector"

	^
	[| y |
	y := self class nrow: ncol.
	self blasInterface 
		gemvWithTransA: self blasInterface transposed
		M: nrow
		N: ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		X: aLapackMatrix arrayPointer
		incX: 1
		beta: 0
		Y: y arrayPointer
		incY: 1.
	y] 
			on: Error
			do: 
				[:exc | 
				exc 
					return: (super productMatrixTransposeWithColumnVector: aLapackMatrix)]! !

!LapackGeneralMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:20'!
productMatrixWithColumnVector: aLapackMatrix 
	"Product Matrix * vector"

	^
	[| y |
	y := self class nrow: nrow.
	self blasInterface 
		gemvWithTransA: self blasInterface notTransposed
		M: nrow
		N: ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		X: aLapackMatrix arrayPointer
		incX: 1
		beta: 0
		Y: y arrayPointer
		incY: 1.
	y] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithColumnVector: aLapackMatrix)]! !

!LapackGeneralMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:21'!
productMatrixWithMatrix: aLapackMatrix 
	"Product Matrix * Matrix"

	^
	[| b c |
	b := aLapackMatrix asGeneralMatrix.
	c := self class nrow: nrow ncol: b ncol.
	self blasInterface 
		gemmWithTransA: self blasInterface notTransposed
		TransB: self blasInterface notTransposed
		M: nrow
		N: b ncol
		K: ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		B: b arrayPointer
		ldb: b nrow
		beta: 0
		C: c arrayPointer
		ldc: c nrow.
	c] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithMatrix: aLapackMatrix)]! !

!LapackGeneralMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:21'!
reciprocal
	nrow = ncol ifFalse: [self error: 'should be square'].
	^[self pluDecomposition inverse] on: Error
		do: [:exc | exc return: super reciprocal]! !

!LapackGeneralMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 22:42'!
smallLowerTriangle: ind 
	"return lower triangle matrix"

	^
	[ind <= 0 
		ifTrue: 
			[| b |
			b := self class triangularMatrix nrow: (nrow + ind max: 1) ncol: (ncol min: (nrow + ind max: 0)).
			b beLower.
			self lapackInterface 
				lacpyWithuplo: self lapackInterface lower
				m: b nrow
				n: b ncol
				a: (self arrayPointerWithOffset: ind negated)
				lda: nrow
				b: (b arrayPointerWithOffset: 0)
				ldb: b nrow.
			b]
		ifFalse: 
			[| b offset |
			offset := (ind + 1) * nrow.
			b := self class nrow: nrow ncol: (ncol min: nrow + ind).
			b copy: b nrow rowsStartingAt: 1 and: b ncol columnsStartingAt: 1 from: self.
			b lapackInterface 
				lasetWithuplo: b lapackInterface upper
				m: (b ncol - ind - 1 min: b nrow)
				n: b ncol - ind - 1
				alpha: 0.0
				beta: 0.0
				a: (b arrayPointerWithOffset: offset)
				lda: b nrow.
			b]] 
			on: Error
			do: [:exc | exc return: (super smallLowerTriangle: ind)]! !

!LapackGeneralMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 22:42'!
smallUpperTriangle: ind 
	"return upper triangle matrix"

	^
	[ind >= 0 
		ifTrue: 
			[| b offset |
			offset := ind * nrow.
			b := self class triangularMatrix nrow: (nrow min: (ncol - ind max: 1)) ncol: (ncol - ind max: 0).
			b beUpper.
			self lapackInterface 
				lacpyWithuplo: self lapackInterface upper
				m: b nrow
				n: b ncol
				a: (self arrayPointerWithOffset: offset)
				lda: nrow
				b: (b arrayPointerWithOffset: 0)
				ldb: b nrow.
			b]
		ifFalse: 
			[| b offset |
			b := self class nrow: (nrow min: ncol - ind) ncol: ncol.
			b copy: b nrow rowsStartingAt: 1 and: b ncol columnsStartingAt: 1 from: self.
			offset := 1 - ind.
			b lapackInterface
				lasetWithuplo: self lapackInterface lower
				m: b nrow - offset
				n: (b nrow - offset min: b ncol)
				alpha: 0.0
				beta: 0.0
				a: (b arrayPointerWithOffset: offset)
				lda: b nrow.
			b]] 
			on: Error
			do: [:exc | exc return: (super smallUpperTriangle: ind)]! !

!LapackGeneralMatrix methodsFor: 'accessing' stamp: 'nice 5/21/2006 02:34'!
swapColumn: j1 withColumn: j2 
	((j1 between: 1 and: ncol) and: [j2 between: 1 and: ncol]) 
		ifFalse: [^self error: 'bad column specification'].
	
	[self blasInterface 
		swapWithN: nrow
		X: (self arrayPointerWithOffset: (j1 - 1) * nrow)
		incX: 1
		Y: (self arrayPointerWithOffset: (j2 - 1) * nrow)
		incY: 1] 
			on: Error
			do: 
				[:exc | 
					1 to: nrow
						do: 
							[:row | 
								self 
									swapRowAt: row
									columnAt: j1
									withRowAt: row
									columnAt: j2].
					exc return: self]! !

!LapackGeneralMatrix methodsFor: 'accessing' stamp: 'nice 5/21/2006 02:35'!
swapRow: i1 withRow: i2 
	((i1 between: 1 and: nrow) and: [i2 between: 1 and: nrow]) 
		ifFalse: [^self error: 'bad row specification'].
	
	[self blasInterface 
		swapWithN: ncol
		X: (self arrayPointerWithOffset: i1 - 1)
		incX: nrow
		Y: (self arrayPointerWithOffset: i2 - 1)
		incY: nrow] 
			on: Error
			do: 
				[:exc | 
					1 to: ncol
						do: 
							[:col | 
								self 
									swapRowAt: i1
									columnAt: col
									withRowAt: i2
									columnAt: col].
					exc return: self]! !

!LapackGeneralMatrix methodsFor: 'converting' stamp: 'nice 8/28/2011 23:38'!
transposed
	| res |
	self isRowMatrix ifTrue: [^self asColumnMatrix].
	self isColumnMatrix ifTrue: [^self asRowMatrix].
	res := self class allocateNrow: ncol ncol: nrow.
	nrow <= ncol
		ifTrue: [0 to: nrow - 1 do: [:i |
				res copy: ncol elementsFrom: self sourceOffset: i sourceIncrement: nrow destOffset: i * ncol destIncrement: 1 ] ]
		ifFalse: [0 to: ncol - 1 do: [:j |
				res copy: nrow elementsFrom: self sourceOffset: j * nrow sourceIncrement: 1 destOffset: j destIncrement: ncol ] ].
	^res! !

!LapackGeneralMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 22:43'!
upperTriangle: ind 
	"return upper triangle matrix"

	^
	[ind >= 0 
		ifTrue: 
			[| b offset |
			offset := ind * nrow.
			b := self class triangularMatrix nrow: nrow ncol: ncol.
			b beUpper.
			self lapackInterface 
				lacpyWithuplo: self lapackInterface upper
				m: (b ncol - ind min: b nrow)
				n: b nrow - ind
				a: (self arrayPointerWithOffset: offset)
				lda: nrow
				b: (b arrayPointerWithOffset: offset)
				ldb: b nrow.
			b]
		ifFalse: 
			[| b offset |
			b := self copy.
			offset := 1 - ind.
			b lapackInterface
				lasetWithuplo: self lapackInterface lower
				m: b nrow - offset
				n: (b nrow - offset min: b ncol)
				alpha: 0.0
				beta: 0.0
				a: (b arrayPointerWithOffset: offset)
				lda: b nrow.
			b]] 
			on: Error
			do: [:exc | exc return: (super upperTriangle: ind)]! !

LapackGeneralMatrix subclass: #LapackSGEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackSGEMatrix commentStamp: '<historical>' prior: 0!
LapackSGEMatrix handles General Matrices (dense storage) composed of single precision real numbers
See superclass for more information.!

!LapackSGEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackSGEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: GeneralMask) 
				bitOr: (RealMask bitOr: SinglePrecisionMask)! !

!LapackSGEMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFloat: aFloat 
	"FAST: avoid super dispatching technique"

	^self scaledByNumber: aFloat! !

!LapackSGEMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:24'!
scale: n elementsBy: alpha increment: incx 
	
	[self blasInterface 
		scalWithN: n
		alpha: alpha asFloat
		X: self arrayPointer
		incX: incx] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							scale: n
							elementsBy: alpha
							increment: incx)]! !

LapackGeneralMatrix subclass: #LapackZGEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackZGEMatrix commentStamp: '<historical>' prior: 0!
LapackZGEMatrix handles General Matrices (dense storage) composed of double precision complex numbers
See superclass for more information.!

!LapackZGEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackZGEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: GeneralMask) 
				bitOr: (ComplexMask bitOr: DoublePrecisionMask)! !

!LapackZGEMatrix methodsFor: 'double dispatching' stamp: ''!
productFromDouble: aDouble 
	"FAST: avoid super dispatching technique"

	^self scaledByNumber: aDouble! !

!LapackZGEMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:29'!
scale: n elementsBy: alpha increment: incx 
	
	[| comp |
	comp := alpha asDoubleComplex.
	comp imaginary isZero 
		ifTrue: 
			[self blasInterface 
				realScalWithN: n
				alpha: comp real
				X: self arrayPointer
				incX: incx]
		ifFalse: 
			[self blasInterface 
				scalWithN: n
				alpha: comp
				X: self arrayPointer
				incX: incx]] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							scale: n
							elementsBy: alpha
							increment: incx)]! !

LapackMatrix subclass: #LapackHalfMatrix
	instanceVariableNames: 'uplo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackHalfMatrix commentStamp: '<historical>' prior: 0!
LapackHalfMatrix has common protocol for those matrices storing only half a triangle.

Subclasses must implement the following messages:
	private
		complementOfRow:column:
		complementOfRow:column:put:

Instance Variables:
	uplo	<SmallInteger>	code indicating if upper or lower triangular matrix is filled
!

!LapackHalfMatrix class methodsFor: 'instance creation' stamp: 'nice 5/21/2006 00:30'!
columns: anArrayOfColumns 
	| aMatrix sizes |
	(anArrayOfColumns isSequenceable 
		and: [anArrayOfColumns allSatisfy: [:aColumn | aColumn isSequenceable]]) 
			ifFalse: 
				[self 
					error: 'a collection of columns should be provided for columns: creation message'].
	sizes := anArrayOfColumns collect: [:e | e size].
	sizes = (1 to: anArrayOfColumns size) 
		ifTrue: 
			[| res nr |
			nr := anArrayOfColumns size.
			res := self allocateShape: nr.
			res beUpper.
			1 to: nr
				do: 
					[:jc | 
					1 to: jc
						do: 
							[:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: ((anArrayOfColumns at: jc) at: ir)]].
			^res].
	sizes = (anArrayOfColumns size to: 1 by: -1) 
		ifTrue: 
			[| res nr |
			nr := anArrayOfColumns size.
			res := self allocateShape: nr.
			res beLower.
			1 to: nr
				do: 
					[:jc | 
					jc to: nr
						do: 
							[:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: ((anArrayOfColumns at: jc) at: ir -jc + 1)]].
			^res].
	sizes asSet size = 1 
		ifFalse: 
			[self 
				error: 'a collection of columns of equal size should be provided for columns: creation message'].
	aMatrix := self generalMatrix columns: anArrayOfColumns.
	^self fromGeneralMatrix: aMatrix! !

!LapackHalfMatrix class methodsFor: 'instance creation' stamp: ''!
eye: aShape 
	^(super eye: aShape)
		beUpper;
		yourself! !

!LapackHalfMatrix class methodsFor: 'private' stamp: ''!
fromGeneralMatrix: aMatrix 
	self subclassResponsibility! !

!LapackHalfMatrix class methodsFor: 'instance creation' stamp: ''!
fromSequence: aRawArray nrow: nr ncol: nc 
	self fromGeneralMatrix: (self generalMatrix 
				fromSequence: aRawArray
				nrow: nr
				ncol: nc)! !

!LapackHalfMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:28'!
packedMatrix
	^self findClassWithFlags: ((self flags bitClear: StorageMask) bitOr: PackedStorageMask)! !

!LapackHalfMatrix class methodsFor: 'instance creation' stamp: 'nice 5/21/2006 00:19'!
rows: anArrayOfRows 
	| aMatrix sizes |
	(anArrayOfRows isSequenceable 
		and: [anArrayOfRows allSatisfy: [:aRow | aRow isSequenceable]]) 
			ifFalse: 
				[self 
					error: 'a collection of rows should be provided for rows: creation message'].
	sizes := anArrayOfRows collect: [:e | e size].
	sizes = (1 to: anArrayOfRows size) 
		ifTrue: 
			[| res nr |
			nr := anArrayOfRows size.
			res := self allocateShape: nr.
			res beLower.
			1 to: nr
				do: 
					[:jc | 
					jc to: nr
						do: 
							[:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: ((anArrayOfRows at: ir) at: jc)]].
			^res].
	sizes = (anArrayOfRows size to: 1 by: -1) 
		ifTrue: 
			[| res nr |
			nr := anArrayOfRows size.
			res := self allocateShape: nr.
			res beUpper.
			1 to: nr
				do: 
					[:jc | 
					1 to: jc
						do: 
							[:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: ((anArrayOfRows at: ir) at: jc - ir + 1)]].
			^res].
	sizes asSet size = 1 
		ifFalse: 
			[self 
				error: 'a collection of columns of equal size should be provided for columns: creation message'].
	aMatrix := self generalMatrix rows: anArrayOfRows.
	^self fromGeneralMatrix: aMatrix! !

!LapackHalfMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:28'!
unpackedMatrix
	^self findClassWithFlags: ((self flags bitClear: StorageMask) bitOr: FullStorageMask)! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
asPackedMatrix
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
asUnpackedMatrix
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger 
	"prefer double index accessing"

	| ir ic |
	ir := (anInteger - 1) \\ nrow + 1.
	ic := (anInteger - 1) // nrow + 1.
	^self rowAt: ir columnAt: ic! !

!LapackHalfMatrix methodsFor: 'accessing' stamp: ''!
at: anInteger put: aNumber 
	"prefer double index accessing"

	| ir ic |
	ir := (anInteger - 1) \\ nrow + 1.
	ic := (anInteger - 1) // nrow + 1.
	^self 
		rowAt: ir
		columnAt: ic
		put: aNumber! !

!LapackHalfMatrix methodsFor: 'initialize-release' stamp: ''!
beLower
	uplo := LowerMask! !

!LapackHalfMatrix methodsFor: 'initialize-release' stamp: ''!
beUpper
	uplo := UpperMask! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
coerceToDoublePrecisionComplexMatrix
	| res |
	res := super coerceToDoublePrecisionComplexMatrix 
				castTo: self class doublePrecisionMatrix complexMatrix.
	self isUpper ifTrue: [res beUpper] ifFalse: [res beLower].
	^res! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
coerceToDoublePrecisionMatrix
	| res |
	res := super coerceToDoublePrecisionMatrix 
				castTo: self class doublePrecisionMatrix.
	self isUpper ifTrue: [res beUpper] ifFalse: [res beLower].
	^res! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
coerceToSinglePrecisionComplexMatrix
	| res |
	res := super coerceToSinglePrecisionComplexMatrix 
				castTo: self class singlePrecisionMatrix complexMatrix.
	self isUpper ifTrue: [res beUpper] ifFalse: [res beLower].
	^res! !

!LapackHalfMatrix methodsFor: 'converting' stamp: ''!
coerceToSinglePrecisionMatrix
	| res |
	res := super coerceToSinglePrecisionMatrix 
				castTo: self class singlePrecisionMatrix.
	self isUpper ifTrue: [res beUpper] ifFalse: [res beLower].
	^res! !

!LapackHalfMatrix methodsFor: 'private' stamp: ''!
complementOfRow: i column: j 
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'private' stamp: ''!
complementOfRow: i column: j put: aNumber 
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromMatrix: aMatrix
	^self asGeneralMatrix differenceFromMatrix: aMatrix! !

!LapackHalfMatrix methodsFor: 'testing' stamp: ''!
isLower
	^(uplo bitAnd: BothUpperLowerMask) = LowerMask! !

!LapackHalfMatrix methodsFor: 'testing' stamp: ''!
isUpper
	^(uplo bitAnd: BothUpperLowerMask) = UpperMask! !

!LapackHalfMatrix methodsFor: 'double dispatching' stamp: ''!
productFromMatrix: aMatrix
	^self asGeneralMatrix productFromMatrix: aMatrix! !

!LapackHalfMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j 
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j put: aNumber 
	self subclassResponsibility! !

!LapackHalfMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromMatrix: aMatrix
	^self asGeneralMatrix sumFromMatrix: aMatrix! !

LapackHalfMatrix subclass: #LapackUnpackedMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackUnpackedMatrix commentStamp: '<historical>' prior: 0!
LapackUnpackedMatrix implement common behaviour for unpacked storage.
Full dense storage is allocated, but only half storage is used (either upper triangle or lower triangle, including diagonal).

In some circonstances, the other triangle might also contain valid data.

Subclasses must implement the following messages:
	private
		complementOfRow:column:


!

LapackUnpackedMatrix subclass: #LapackUnpackedHermitianMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackUnpackedHermitianMatrix commentStamp: '<historical>' prior: 0!
LapackUnpackedHermitianMatrix is an abstract class for matrices having hermitian property:
	(M rowAt: i columnAt: j) = (M rowAt: j columnAt: i) conjugated

Diagonal of Hermitian Matrices must have zero imaginary part.

Storage is allocated for the n*n elements.
But only half triangle and main diagonal need being stored.
Variable uplo does indicate which one, upper, lower or both.

Subclasses are specialized for containing either real or complex numbers with a specific floating point format.

Note that real symmetric matrices are also hermitian...


!

LapackUnpackedHermitianMatrix subclass: #LapackCHEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackCHEMatrix commentStamp: '<historical>' prior: 0!
LapackCHEMatrix handles Hermitian matrices composed of single precision complex numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackCHEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackCHEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags :=  (FullStorageMask bitOr: HermitianMask) 
				bitOr: (ComplexMask bitOr: SinglePrecisionMask)! !

!LapackUnpackedHermitianMatrix class methodsFor: 'private' stamp: ''!
fromGeneralMatrix: aMatrix 
	| new |
	^aMatrix isHermitian 
		ifTrue: 
			[new := aMatrix castTo: self.
			new beBothUpperLower.
			new]
		ifFalse: [aMatrix]! !

!LapackUnpackedHermitianMatrix class methodsFor: 'instance creation' stamp: 'nice 3/19/2014 23:52'!
nrow: nr ncol: nc withAll: aNumber 
	"cannot be hermitian if not square or complex"

	| aMatrix |
	aMatrix := self generalMatrix 
				nrow: nr
				ncol: nc
				withAll: aNumber.
	(aNumber reduce" toMinimumGenerality" isComplexNumber not and: [aMatrix isSquare]) 
		ifTrue: 
			[aMatrix := aMatrix castTo: self.
			aMatrix beUpper].
	^aMatrix! !

!LapackUnpackedHermitianMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:25'!
absMax
	^self class isComplexMatrix 
		ifTrue: 
			[
			[self lapackInterface 
				lanheWithnorm: self lapackInterface maxAbs
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super absMax]]
		ifFalse: 
			[
			[self lapackInterface 
				lansyWithnorm: self lapackInterface maxAbs
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super absMax]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'initialize-release' stamp: ''!
beBothUpperLower
	"This means that both upper and lower triangles are set"

	uplo := BothUpperLowerMask! !

!LapackUnpackedHermitianMatrix methodsFor: 'converting' stamp: ''!
coerceToGeneralMatrix
	"Implementation Notes: we need to set both upper and lower"

	| a |
	self fillOtherTriangle.
	a := self class generalMatrix allocateNrow: nrow ncol: ncol.
	a 
		copy: self size
		elementsFrom: self
		sourceIncrement: 1
		destIncrement: 1.
	^a! !

!LapackUnpackedHermitianMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:06'!
coercingFromComplexNumber: aComplex do: aBlock 
	"a hermitian matrix will loose its property when
	multiplied by/added to/divided by aComplex"

	^self asGeneralMatrix coercingFromComplexNumber: aComplex do: aBlock! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: ''!
complementOfRow: i column: j 
	^(self rowAt: i columnAt: j) conjugated! !

!LapackUnpackedHermitianMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	| diag |
	((index > 0 and: [self isLower]) or: [index < 0 and: [self isUpper]]) 
		ifTrue: [^(self diagonalAt: index negated) conjugated].
	diag := self class nrow: (self diagonalSizeAt: index).
	index >= 0 
		ifTrue: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index * nrow
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1]
		ifFalse: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index negated
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1].
	^diag! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: ''!
differenceWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class.
	but are they both upper / lower ?"

	| res |
	((aLapackMatrix isUpper and: [self isLower]) 
		or: [aLapackMatrix isLower and: [self isUpper]]) 
			ifTrue: [aLapackMatrix fillOtherTriangle].
	res := self copy.
	res 
		fill: self size
		elementsWithStride: 1
		withSelfPlusScalar: -1
		timesVector: aLapackMatrix
		stride: 1.
	aLapackMatrix isBothUpperLower 
		ifTrue: 
			[self isUpper 
				ifTrue: [res beUpper]
				ifFalse: [self isLower ifTrue: [res beLower]]].
	^res! !

!LapackUnpackedHermitianMatrix methodsFor: 'decomposition' stamp: ''!
eigenValueDecomposition
	^LapackHermitianEigenDecomposition decompose: self! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: 'nice 5/21/2006 02:25'!
fillLowerTriangleLapack
	"Try using BLAS/LAPACK primitives for larger matrices"

	
	[| blas |
	blas := self blasInterface.
	self class isComplexMatrix 
		ifTrue: 
			[| lapack |
			lapack := self lapackInterface.
			1 to: nrow - 1
				do: 
					[:i | 
					"Copy a row to a column"
					blas 
						copyWithN: nrow - i
						X: (self arrayPointerWithOffset: (i * nrow) + i - 1)
						incX: nrow
						Y: (self arrayPointerWithOffset: (i - 1) * nrow + i)
						incY: 1.
					"Conjugate the column"
					lapack 
						lacgvWithn: nrow - i
						x: (self arrayPointerWithOffset: (i - 1) * nrow + i)
						incx: 1]]
		ifFalse: 
			[1 to: nrow - 1
				do: 
					[:i | 
					blas 
						copyWithN: nrow - i
						X: (self arrayPointerWithOffset: (i * nrow) + i - 1)
						incX: nrow
						Y: (self arrayPointerWithOffset: (i - 1) * nrow + i)
						incY: 1]]] 
			on: Error
			do: [:exc | exc return: self fillLowerTriangleNaive].
	self beBothUpperLower! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: ''!
fillLowerTriangleNaive
	"fill lower triangle.
	naive element by element algorithm"

	self class isComplexMatrix 
		ifTrue: 
			[2 to: nrow do: [:i | 
				1 to: nrow - 1 do: [:j | 
					self 
						rowAt: i
						columnAt: j
						put: (self rowAt: j columnAt: i) conjugated]]]
		ifFalse: 
			[2 to: nrow do: [:i | 
				1 to: nrow - 1 do: [:j | 
					self 
						rowAt: i
						columnAt: j
						put: (self rowAt: j columnAt: i)]]].
	self beBothUpperLower! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: ''!
fillOtherTriangle
	self isBothUpperLower ifTrue: [^self].
	self isUpper 
		ifTrue: 
			["fill lower triangle"

			nrow < 10 
				ifTrue: [self fillLowerTriangleNaive]
				ifFalse: [self fillLowerTriangleLapack]]
		ifFalse: 
			["fill upper triangle"

			nrow < 10 
				ifTrue: [self fillUpperTriangleNaive]
				ifFalse: [self fillUpperTriangleLapack]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'initialize-release' stamp: ''!
fillRandNormalWithSeed: seedArray 
	"A Hermitian Matrix should have a real diagonal"

	super fillRandNormalWithSeed: seedArray.
	self class isComplexMatrix 
		ifTrue: 
			[| diag |
			diag := self diagonal.
			diag imaginaryPart isZero ifFalse: [self setDiagonal: diag realPart]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'initialize-release' stamp: ''!
fillRandUniformWithSeed: seedArray 
	"A Hermitian Matrix should have a real diagonal"

	super fillRandUniformWithSeed: seedArray.
	self class isComplexMatrix 
		ifTrue: 
			[| diag |
			diag := self diagonal.
			diag imaginaryPart isZero ifFalse: [self setDiagonal: diag realPart]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: 'nice 5/21/2006 02:25'!
fillUpperTriangleLapack
	"Try using BLAS/LAPACK primitives for larger matrices"

	
	[| blas |
	blas := self blasInterface.
	self class isComplexMatrix 
		ifTrue: 
			[| lapack |
			lapack := self lapackInterface.
			1 to: nrow - 1
				do: 
					[:i | 
					"Copy a column to a row"
					blas 
						copyWithN: nrow - i
						X: (self arrayPointerWithOffset: (i - 1) * nrow + i)
						incX: 1
						Y: (self arrayPointerWithOffset: (i * nrow) + i - 1)
						incY: nrow.
					"Conjugate the row"
					lapack 
						lacgvWithn: nrow - i
						x: (self arrayPointerWithOffset: (i * nrow) + i - 1)
						incx: nrow]]
		ifFalse: 
			[1 to: nrow - 1
				do: 
					[:i | 
					blas 
						copyWithN: nrow - i
						X: (self arrayPointerWithOffset: (i - 1) * nrow + i)
						incX: 1
						Y: (self arrayPointerWithOffset: (i * nrow) + i - 1)
						incY: nrow]]] 
			on: Error
			do: [:exc | exc return: self fillUpperTriangleNaive].
	self beBothUpperLower! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: ''!
fillUpperTriangleNaive
	"fill upper triangle.
	naive element by element algorithm"

	self class isComplexMatrix 
		ifTrue: 
			[2 to: nrow do: [:i | 
				1 to: nrow - 1 do: [:j | 
					self 
						rowAt: j
						columnAt: i
						put: (self rowAt: i columnAt: j) conjugated]]]
		ifFalse: 
			[2 to: nrow do: [:i | 
				1 to: nrow - 1 do: [:j | 
					self 
						rowAt: j
						columnAt: i
						put: (self rowAt: i columnAt: j)]]].
	self beBothUpperLower! !

!LapackUnpackedHermitianMatrix methodsFor: 'private' stamp: 'nice 5/20/2006 02:58'!
inPlaceSolve: b 
	"find x such that self*x=b, that is solve a linear system of equations
	BEWARE: this will destroy matrices self and b
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
		info contains error code if not 0"

	| ipiv info |
	ipiv := ExternalLongArray new: nrow.
	info := self lapackInterface 
				hesvWithuplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: nrow
				nrhs: b ncol
				a: self arrayPointer
				lda: nrow
				ipiv: ipiv arrayPointer
				b: b arrayPointer
				ldb: b nrow.
	info = 0 ifFalse: [self error: 'inversion failed'].
	^b! !

!LapackUnpackedHermitianMatrix methodsFor: 'testing' stamp: ''!
isBothUpperLower
	^uplo = BothUpperLowerMask! !

!LapackUnpackedHermitianMatrix methodsFor: 'testing' stamp: ''!
isHermitian
	^true! !

!LapackUnpackedHermitianMatrix methodsFor: 'testing' stamp: ''!
isSymmetric
	^self imaginaryPart isZero! !

!LapackUnpackedHermitianMatrix methodsFor: 'accessing-submatrix' stamp: ''!
lowerTriangle: ind 
	"return lower triangle matrix"

	(ind <= 0 and: [self isLower]) ifFalse: [self fillOtherTriangle].
	^(self castTo: self class generalMatrix) lowerTriangle: ind! !

!LapackUnpackedHermitianMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:25'!
norm1
	^self class isComplexMatrix 
		ifTrue: 
			[
			[self lapackInterface 
				lanheWithnorm: self lapackInterface norm1
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super norm1]]
		ifFalse: 
			[
			[self lapackInterface 
				lansyWithnorm: self lapackInterface norm1
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super norm1]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:26'!
normFrobenius
	^self class isComplexMatrix 
		ifTrue: 
			[
			[self lapackInterface 
				lanheWithnorm: self lapackInterface normF
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super normFrobenius]]
		ifFalse: 
			[
			[self lapackInterface 
				lansyWithnorm: self lapackInterface normF
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super normFrobenius]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:26'!
normInfinity
	^self class isComplexMatrix 
		ifTrue: 
			[
			[self lapackInterface 
				lanheWithnorm: self lapackInterface normI
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super normInfinity]]
		ifFalse: 
			[
			[self lapackInterface 
				lansyWithnorm: self lapackInterface normI
				uplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				n: ncol
				a: self arrayPointer
				lda: nrow] 
					on: Error
					do: [:exc | exc return: super normInfinity]]! !

!LapackUnpackedHermitianMatrix methodsFor: 'decomposition' stamp: ''!
pluDecomposition
	^LapackHermitianPLUdecomposition decompose: self! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:26'!
productMatrixAtRightWithMatrix: aLapackMatrix 
	"the other matrix must have conforming precision and complexity"

	^
	[| b c blas |
	self class = aLapackMatrix class 
		ifTrue: 
			["product of two hermitian is hermitian"

			aLapackMatrix fillOtherTriangle.
			b := aLapackMatrix.
			c := aLapackMatrix zero]
		ifFalse: 
			["else, general"

			b := aLapackMatrix asGeneralMatrix.
			c := aLapackMatrix class generalMatrix nrow: aLapackMatrix nrow ncol: ncol].
	blas := self blasInterface.
	blas 
		hemmWithSide: blas right
		Uplo: (self isUpper 
				ifTrue: [blas upper]
				ifFalse: [blas lower])
		M: b nrow
		N: b ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		B: b arrayPointer
		ldb: b nrow
		beta: 0
		C: c arrayPointer
		ldc: c nrow.
	c] 
			on: Error
			do: [:exc | exc return: (super productMatrixAtRightWithMatrix: aLapackMatrix)]! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: ''!
productMatrixTransposeWithColumnVector: aLapackMatrix 
	"the vector must have conforming precision and complexity
	BLAS do not handle transpose of hermitian..."

	^self transposed productMatrixWithColumnVector: aLapackMatrix! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:26'!
productMatrixWithColumnVector: aLapackMatrix 
	"the vector must have conforming precision and complexity"

	^
	[| y |
	y := aLapackMatrix class nrow: nrow.
	self blasInterface 
		hemvWithUplo: (self isUpper 
				ifTrue: [self blasInterface upper]
				ifFalse: [self blasInterface lower])
		N: nrow
		alpha: 1
		A: self arrayPointer
		lda: nrow
		X: aLapackMatrix arrayPointer
		incX: 1
		beta: 0
		Y: y arrayPointer
		incY: 1.
	y] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithColumnVector: aLapackMatrix)]! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:26'!
productMatrixWithMatrix: aLapackMatrix 
	"the other matrix must have conforming precision and complexity
	NOTE : product of two hermitian is not hermitian"

	^
	[| b c blas |
	self class = aLapackMatrix class ifTrue: [aLapackMatrix fillOtherTriangle].
	b := aLapackMatrix asGeneralMatrix.
	c := b class allocateNrow: nrow ncol: aLapackMatrix ncol.
	blas := self blasInterface.
	blas 
		hemmWithSide: blas left
		Uplo: (self isUpper ifTrue: [blas upper] ifFalse: [blas lower])
		M: b nrow
		N: b ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		B: b arrayPointer
		ldb: b nrow
		beta: 0
		C: c arrayPointer
		ldc: c nrow.
	c] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithMatrix: aLapackMatrix)]! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:27'!
reciprocal
	^[self pluDecomposition inverse] on: Error
		do: [:exc | exc return: super reciprocal]! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: ''!
scaledByComplex: aComplex 
	"a Hermitian Matrix when scaled by complex number is no more hermitian... It is general"

	aComplex imaginary isZero ifTrue: [^self scaledByNumber: aComplex real].
	^self asGeneralMatrix scaledByComplex: aComplex! !

!LapackUnpackedHermitianMatrix methodsFor: 'initialize-release' stamp: ''!
setArray: anArray nrow: nr ncol: nc 
	self beBothUpperLower.
	super 
		setArray: anArray
		nrow: nr
		ncol: nc! !

!LapackUnpackedHermitianMatrix methodsFor: 'decomposition' stamp: ''!
singularValueDecomposition
	self fillOtherTriangle.
	^super singularValueDecomposition! !

!LapackUnpackedHermitianMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 14:36'!
smallLowerTriangle: ind 
	"return lower triangle matrix"

	(ind <= 0 and: [self isLower]) ifFalse: [self fillOtherTriangle].
	^(self castTo: self class generalMatrix) smallLowerTriangle: ind! !

!LapackUnpackedHermitianMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 2/19/2009 13:53'!
smallUpperTriangle: ind 
	"return upper triangle matrix"

	(ind >= 0 and: [self isUpper]) ifFalse: [self fillOtherTriangle].
	^(self castTo: self class generalMatrix) smallUpperTriangle: ind! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: ''!
sumWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class.
	but are they both upper / lower ?"

	| res |
	((aLapackMatrix isUpper and: [self isLower]) 
		or: [aLapackMatrix isLower and: [self isUpper]]) 
			ifTrue: [self fillOtherTriangle].
	res := self copy.
	res 
		fill: self size
		elementsWithStride: 1
		withSelfPlusScalar: 1
		timesVector: aLapackMatrix
		stride: 1.
	self isBothUpperLower 
		ifTrue: 
			[aLapackMatrix isUpper 
				ifTrue: [res beUpper]
				ifFalse: [aLapackMatrix isLower ifTrue: [res beLower]]].
	^res! !

!LapackUnpackedHermitianMatrix methodsFor: 'arithmetic' stamp: ''!
transposeConjugated
	^self! !

!LapackUnpackedHermitianMatrix methodsFor: 'converting' stamp: ''!
transposed
	^self conjugated! !

!LapackUnpackedHermitianMatrix methodsFor: 'accessing-submatrix' stamp: ''!
upperTriangle: ind 
	"return upper triangle matrix"

	(ind >= 0 and: [self isUpper]) ifFalse: [self fillOtherTriangle].
	^(self castTo: self class generalMatrix) upperTriangle: ind! !

LapackUnpackedHermitianMatrix subclass: #LapackUnpackedSymmetricRealMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackUnpackedSymmetricRealMatrix commentStamp: '<historical>' prior: 0!
LapackUnpackedSymmetricRealMatrix is an abstract class for matrices having symmetric property:
	(M rowAt: i columnAt: j) = (M rowAt: j columnAt: i)
Symmetric Complex Matrices are not considered since they have few interesting properties.

As stated in super class, only half triangle and diagonal need being stored.
Variable uplo does indicate which one, upper, lower or both.

Subclasses are specialized for containing either real numbers with a specific floating point format.

!

LapackUnpackedSymmetricRealMatrix subclass: #LapackDSYMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackDSYMatrix commentStamp: '<historical>' prior: 0!
LapackDSYMatrix handles Symmetric matrices composed of double precision real numbers
Dense storage is allocated but only half is used.
See superclass for more information.

!

!LapackDSYMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackDSYMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: HermitianMask) 
				bitOr: (RealMask bitOr: DoublePrecisionMask)! !

LapackUnpackedSymmetricRealMatrix subclass: #LapackSSYMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackSSYMatrix commentStamp: '<historical>' prior: 0!
LapackSSYMatrix handles Symmetric matrices composed of single precision real numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackSSYMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackSSYMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: HermitianMask) 
				bitOr: (RealMask bitOr: SinglePrecisionMask)! !

!LapackUnpackedSymmetricRealMatrix class methodsFor: 'private' stamp: ''!
fromGeneralMatrix: aMatrix 
	| new |
	^aMatrix isSymmetric 
		ifTrue: 
			[new := aMatrix castTo: self.
			new beBothUpperLower.
			new]
		ifFalse: [aMatrix]! !

!LapackUnpackedSymmetricRealMatrix methodsFor: 'private' stamp: ''!
complementOfRow: i column: j 
	^self rowAt: i columnAt: j! !

!LapackUnpackedSymmetricRealMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	| diag |
	((index > 0 and: [self isLower]) or: [index < 0 and: [self isUpper]]) 
		ifTrue: [^self diagonalAt: index negated].
	diag := self class nrow: (self diagonalSizeAt: index).
	index >= 0 
		ifTrue: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index * nrow
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1]
		ifFalse: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index negated
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1].
	^diag! !

!LapackUnpackedSymmetricRealMatrix methodsFor: 'testing' stamp: ''!
isSymmetric
	^true! !

!LapackUnpackedSymmetricRealMatrix methodsFor: 'converting' stamp: ''!
transposed
	^self! !

LapackUnpackedHermitianMatrix subclass: #LapackZHEMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackZHEMatrix commentStamp: '<historical>' prior: 0!
LapackZHEMatrix handles Hermitian matrices composed of double precision complex numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackZHEMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackZHEMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: HermitianMask) 
				bitOr: (ComplexMask bitOr: DoublePrecisionMask)! !

!LapackUnpackedMatrix class methodsFor: 'private' stamp: ''!
allocateNrow: nr ncol: nc 
	^nr = nc 
		ifTrue: [(super allocateNrow: nr ncol: nc) beUpper; yourself]
		ifFalse: [self generalMatrix allocateNrow: nr ncol: nc]! !

!LapackUnpackedMatrix methodsFor: 'converting' stamp: ''!
asPackedMatrix
	^self coerceToPackedMatrix! !

!LapackUnpackedMatrix methodsFor: 'converting' stamp: ''!
asUnpackedMatrix
	^self! !

!LapackUnpackedMatrix methodsFor: 'converting' stamp: 'nice 5/17/2006 22:50'!
coerceToPackedMatrix
	"Create a packed form with a copy of self.
	proceed column by column"

	| blas packed |
	blas := self blasInterface.
	packed := self class packedMatrix allocateShape: nrow.
	self isUpper 
		ifTrue: 
			[packed beUpper.
			
			[1 to: ncol
				do: 
					[:jc | 
					blas 
						copyWithN: jc
						X: (self arrayPointerWithOffset: (self arrayOffsetAtRow: 1 atColumn: jc))
						incX: 1
						Y: (packed arrayPointerWithOffset: (packed arrayOffsetAtRow: 1 atColumn: jc))
						incY: 1]] 
					on: Error
					do: 
						[:exc | 
						1 to: ncol do: [:jc | 
								1 to: jc do: [:ir | 
										packed 
											rowAt: ir
											columnAt: jc
											put: (self rowAt: ir columnAt: jc)]]]]
		ifFalse: 
			[packed beLower.
			
			[1 to: ncol
				do: 
					[:jc | 
					blas 
						copyWithN: ncol - (jc - 1)
						X: (self arrayPointerWithOffset: (self arrayOffsetAtRow: jc atColumn: jc))
						incX: 1
						Y: (packed arrayPointerWithOffset: (packed arrayOffsetAtRow: jc atColumn: jc))
						incY: 1]] 
					on: Error
					do: 
						[:exc | 
						1 to: ncol do: [:jc | 
								jc to: nrow do: [:ir | 
										packed 
											rowAt: ir
											columnAt: jc
											put: (self rowAt: ir columnAt: jc)]]]].
	^packed! !

!LapackUnpackedMatrix methodsFor: 'converting' stamp: ''!
coerceToUnpackedMatrix
	^self! !

!LapackUnpackedMatrix methodsFor: 'private' stamp: ''!
complementOfRow: ir column: jc put: aNumber 
	"handle triangular/hermitian property
	Implementation Notes : cannot use changeClassTo: because uplo instVar"

	^aNumber = (self complementOfRow: ir column: jc) 
		ifTrue: [array at: (ir - 1) * nrow + jc put: aNumber]
		ifFalse: 
			[| coerced |
			self fillOtherTriangle.
			coerced := self castTo: self class generalMatrix.
			coerced 
				rowAt: jc
				columnAt: ir
				put: aNumber.
			self become: coerced.
			aNumber]! !

!LapackUnpackedMatrix methodsFor: 'private' stamp: ''!
fillOtherTriangle
	self subclassResponsibility! !

!LapackUnpackedMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j 
	^self isUpper 
		ifTrue: 
			[i <= j 
				ifTrue: [self arrayAt: (j - 1) * nrow + i]
				ifFalse: [self complementOfRow: j column: i]]
		ifFalse: 
			[j <= i 
				ifTrue: [self arrayAt: (j - 1) * nrow + i]
				ifFalse: [self complementOfRow: j column: i]]! !

!LapackUnpackedMatrix methodsFor: 'accessing' stamp: ''!
rowAt: i columnAt: j put: aNumber 
	^self isUpper 
		ifTrue: 
			[i <= j 
				ifTrue: [array at: (j - 1) * nrow + i put: aNumber]
				ifFalse: 
					[self 
						complementOfRow: j
						column: i
						put: aNumber]]
		ifFalse: 
			[j <= i 
				ifTrue: [array at: (j - 1) * nrow + i put: aNumber]
				ifFalse: 
					[self 
						complementOfRow: j
						column: i
						put: aNumber]]! !

LapackUnpackedMatrix subclass: #LapackUnpackedTriangularMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackUnpackedTriangularMatrix commentStamp: '<historical>' prior: 0!
LapackUnpackedTriangularMatrix is an abstract class for matrices having triangular property:
	(M rowAt: i columnAt: j) = 0 for j > i for a lower triangular.
	(M rowAt: i columnAt: j) = 0 for i > j for a upper triangular.

Only half triangle and diagonal need being stored.
Variable uplo does indicate which one, upper, lower.

Subclasses are specialized for containing either real or complex numbers with a specific floating point format.


!

LapackUnpackedTriangularMatrix subclass: #LapackCTRMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackCTRMatrix commentStamp: '<historical>' prior: 0!
LapackCTRMatrix handles Triangular matrices composed of single precision complex numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackCTRMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackCTRMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: TriangularMask) 
				bitOr: (ComplexMask bitOr: SinglePrecisionMask)! !

LapackUnpackedTriangularMatrix subclass: #LapackDTRMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackDTRMatrix commentStamp: '<historical>' prior: 0!
LapackDTRMatrix handles Triangular matrices composed of double precision real numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackDTRMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackDTRMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: TriangularMask) 
				bitOr: (RealMask bitOr: DoublePrecisionMask)! !

LapackUnpackedTriangularMatrix subclass: #LapackSTRMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackSTRMatrix commentStamp: '<historical>' prior: 0!
LapackSTRMatrix handles Triangular matrices composed of single precision real numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackSTRMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackSTRMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: TriangularMask) 
				bitOr: (RealMask bitOr: SinglePrecisionMask)! !

!LapackUnpackedTriangularMatrix class methodsFor: 'private' stamp: ''!
fromGeneralMatrix: aMatrix 
	| new |
	^aMatrix isLowerTriangular 
		ifTrue: 
			[new := aMatrix castTo: self.
			new beLower.
			new]
		ifFalse: 
			[aMatrix isUpperTriangular 
				ifTrue: 
					[new := aMatrix castTo: self.
					new beUpper.
					new]
				ifFalse: [aMatrix]]! !

!LapackUnpackedTriangularMatrix class methodsFor: 'instance creation' stamp: ''!
nrow: nr ncol: nc withAll: aNumber 
	"cannot be triangular if not all zero"

	| aMatrix |
	aMatrix := self generalMatrix 
				nrow: nr
				ncol: nc
				withAll: aNumber.
	(aNumber isZero and: [aMatrix isSquare])
		ifTrue: 
			[aMatrix := aMatrix castTo: self.
			aMatrix beUpper].
	^aMatrix! !

!LapackUnpackedTriangularMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:27'!
absMax
	^
	[self lapackInterface 
		lantrWithnorm: self lapackInterface maxAbs
		uplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		diag: self lapackInterface nonUnit
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super absMax]! !

!LapackUnpackedTriangularMatrix methodsFor: 'converting' stamp: 'nice 5/21/2006 02:27'!
coerceToGeneralMatrix
	"Implementation Notes: a is already set to zero, we need only updating upper or lower"

	^
	[| b |
	b := self class generalMatrix nrow: nrow ncol: ncol.
	self lapackInterface 
		lacpyWithuplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow
		b: b arrayPointer
		ldb: b nrow.
	b] 
			on: Error
			do: [:exc | exc return: super coerceToGeneralMatrix]! !

!LapackUnpackedTriangularMatrix methodsFor: 'private' stamp: ''!
complementOfRow: i column: j 
	^0! !

!LapackUnpackedTriangularMatrix methodsFor: 'accessing-submatrix' stamp: ''!
diagonalAt: index 
	| diag |
	diag := self class nrow: (self diagonalSizeAt: index).
	(index >= 0 and: [self isUpper]) 
		ifTrue: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index * nrow
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1].
	(index <= 0 and: [self isLower]) 
		ifTrue: 
			[diag 
				copy: diag size
				elementsFrom: self
				sourceOffset: index negated
				sourceIncrement: nrow + 1
				destOffset: 0
				destIncrement: 1].
	^diag! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: ''!
differenceWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class.
	but are they both upper / lower ?"

	| res |
	res := self copy.
	res 
		fill: self size
		elementsWithStride: 1
		withSelfPlusScalar: -1
		timesVector: aLapackMatrix
		stride: 1.
	(self isUpper xor: aLapackMatrix isUpper) 
		ifTrue: [res := res castTo: self class generalMatrix].
	^res! !

!LapackUnpackedTriangularMatrix methodsFor: 'decomposition' stamp: ''!
eigenValues
	^self diagonal! !

!LapackUnpackedTriangularMatrix methodsFor: 'private' stamp: ''!
fillOtherTriangle
	"nothing to do, because the other triangle is set to zero by default"

	^self! !

!LapackUnpackedTriangularMatrix methodsFor: 'private' stamp: ''!
inPlaceSolve: b 
	"find x such that self*x=b, that is solve a linear system of equations
	BEWARE: this will destroy matrices self and b
	on return:
		x is stored in b on return
		a contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		info contains error code if not 0"

	| info |
	info := self lapackInterface 
				trtrsWithuplo: (self isUpper 
						ifTrue: [self lapackInterface upper]
						ifFalse: [self lapackInterface lower])
				trans: self lapackInterface notTransposed
				diag: self lapackInterface nonUnit
				n: nrow
				nrhs: b ncol
				a: self arrayPointer
				lda: nrow
				b: b arrayPointer
				ldb: b nrow.
	info = 0 ifFalse: [self error: 'inversion failed'].
	^b! !

!LapackUnpackedTriangularMatrix methodsFor: 'testing' stamp: ''!
isLowerTriangular
	^self isLower or: [self isDiagonal]! !

!LapackUnpackedTriangularMatrix methodsFor: 'testing' stamp: ''!
isTriangular
	^true! !

!LapackUnpackedTriangularMatrix methodsFor: 'testing' stamp: ''!
isUpperTriangular
	^self isUpper or: [self isDiagonal]! !

!LapackUnpackedTriangularMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 5/21/2006 02:27'!
lowerTriangle: ind 
	"return lower triangle matrix"

	^
	[self isLower 
		ifTrue: 
			[ind >= 0 
				ifTrue: [self]
				ifFalse: 
					[| b offset |
					offset := ind negated.
					b := self class triangularMatrix nrow: nrow ncol: ncol.
					b beLower.
					self lapackInterface 
						lacpyWithuplo: self lapackInterface lower
						m: nrow + ind
						n: ncol + ind
						a: (self arrayPointerWithOffset: offset)
						lda: nrow
						b: (b arrayPointerWithOffset: offset)
						ldb: b nrow.
					b]]
		ifFalse: 
			[ind = 0 
				ifTrue: 
					[| b |
					b := self class triangularMatrix nrow: nrow ncol: ncol.
					b beLower.
					b setDiagonal: self diagonal.
					b]
				ifFalse: [self zero]]] 
			on: Error
			do: [:exc | exc return: (super lowerTriangle: ind)]! !

!LapackUnpackedTriangularMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:27'!
norm1
	^
	[self lapackInterface 
		lantrWithnorm: self lapackInterface norm1
		uplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		diag: self lapackInterface nonUnit
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super norm1]! !

!LapackUnpackedTriangularMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:27'!
normFrobenius
	^
	[self lapackInterface 
		lantrWithnorm: self lapackInterface normF
		uplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		diag: self lapackInterface nonUnit
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super normFrobenius]! !

!LapackUnpackedTriangularMatrix methodsFor: 'norm' stamp: 'nice 5/21/2006 02:27'!
normInfinity
	^
	[self lapackInterface 
		lantrWithnorm: self lapackInterface normI
		uplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		diag: self lapackInterface nonUnit
		m: nrow
		n: ncol
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: super normInfinity]! !

!LapackUnpackedTriangularMatrix methodsFor: 'decomposition' stamp: ''!
pluDecomposition
	^LapackTriangularPLUdecomposition decompose: self! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:28'!
productMatrixAtRightWithMatrix: aLapackMatrix 
	"the other matrix must have conforming precision and complexity"

	^
	[| b blas |
	b := (aLapackMatrix class = self class 
				and: [aLapackMatrix isUpper == self isUpper]) 
					ifTrue: 
						["Product of two upper triangular is upper triangular.
						Same for two lower."

						aLapackMatrix copy]
					ifFalse: 
						["Else, no known property, answer a generalMatrix"

						aLapackMatrix copy castTo: aLapackMatrix class generalMatrix].
	blas := self blasInterface.
	blas 
		trmmWithSide: blas right
		Uplo: (self isUpper ifTrue: [blas upper] ifFalse: [blas lower])
		TransA: blas notTransposed
		Diag: blas nonUnit
		M: b nrow
		N: b ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		B: b arrayPointer
		ldb: b nrow.
	b] 
			on: Error
			do: [:exc | exc return: (super productMatrixAtRightWithMatrix: aLapackMatrix)]! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:28'!
productMatrixTransposeWithColumnVector: aLapackMatrix 
	"the vector must have conforming precision and complexity"

	^
	[| x blas |
	x := aLapackMatrix copy.
	blas := self blasInterface.
	blas 
		trmvWithUplo: (self isUpper 
				ifTrue: [blas upper]
				ifFalse: [blas lower])
		TransA: blas transposed
		Diag: blas nonUnit
		N: x size
		A: self arrayPointer
		lda: nrow
		X: x arrayPointer
		incX: 1.
	x] 
			on: Error
			do: [:exc | exc return: (super productMatrixTransposeWithColumnVector: aLapackMatrix)]! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:28'!
productMatrixWithColumnVector: aLapackMatrix 
	"the vector must have conforming precision and complexity"

	^
	[| x blas |
	x := aLapackMatrix copy.
	blas := self blasInterface.
	blas 
		trmvWithUplo: (self isUpper ifTrue: [blas upper] ifFalse: [blas lower])
		TransA: blas notTransposed
		Diag: blas nonUnit
		N: x size
		A: self arrayPointer
		lda: nrow
		X: x arrayPointer
		incX: 1.
	x] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithColumnVector: aLapackMatrix)]! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:28'!
productMatrixWithMatrix: aLapackMatrix 
	"the other matrix must have conforming precision and complexity"

	^
	[| b blas |
	b := (aLapackMatrix class = self class 
				and: [aLapackMatrix isUpper == self isUpper]) 
					ifTrue: 
						["Product of two upper triangular is upper triangular.
						Same for two lower."

						aLapackMatrix copy]
					ifFalse: 
						["Else, no known property, answer a generalMatrix"

						aLapackMatrix copy castTo: aLapackMatrix class generalMatrix].
	blas := self blasInterface.
	blas 
		trmmWithSide: blas left
		Uplo: (self isUpper ifTrue: [blas upper] ifFalse: [blas lower])
		TransA: blas notTransposed
		Diag: blas nonUnit
		M: b nrow
		N: b ncol
		alpha: 1
		A: self arrayPointer
		lda: nrow
		B: b arrayPointer
		ldb: b nrow.
	b] 
			on: Error
			do: [:exc | exc return: (super productMatrixWithMatrix: aLapackMatrix)]! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: 'nice 2/20/2009 03:51'!
reciprocal
	^
	[| inv |
	inv := self copy.
	self lapackInterface 
		trtriWithuplo: (self isUpper 
				ifTrue: [self lapackInterface upper]
				ifFalse: [self lapackInterface lower])
		diag: self lapackInterface nonUnit
		n: ncol
		a: inv arrayPointer
		lda: nrow.
	inv] 
			on: Error
			do: [:exc | exc return: super reciprocal]! !

!LapackUnpackedTriangularMatrix methodsFor: 'arithmetic' stamp: ''!
sumWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class.
	but are they both upper / lower ?"

	| res |
	res := self copy.
	res 
		fill: self size
		elementsWithStride: 1
		withSelfPlusScalar: 1
		timesVector: aLapackMatrix
		stride: 1.
	(self isUpper xor: aLapackMatrix isUpper) 
		ifTrue: [res := res castTo: self class generalMatrix].
	^res! !

!LapackUnpackedTriangularMatrix methodsFor: 'converting' stamp: 'nice 8/28/2011 23:33'!
transposed
	| res |
	nrow = 1 ifTrue: [^self].
	res := self class allocateNrow: ncol ncol: nrow.
	self isUpper
		ifTrue:
			[res beLower.
			0 to: nrow - 1 do: [:i |
				res copy: ncol - i elementsFrom: self sourceOffset: i * nrow + i sourceIncrement: nrow destOffset: i * ncol + i destIncrement: 1 ] ]
		ifFalse: 
			[res beUpper.
			0 to: ncol - 1 do: [:i |
				res copy: nrow - i elementsFrom: self sourceOffset: i * nrow + i sourceIncrement: 1 destOffset: i * ncol + i destIncrement: ncol ] ].
	^res! !

!LapackUnpackedTriangularMatrix methodsFor: 'accessing-submatrix' stamp: 'nice 5/21/2006 02:28'!
upperTriangle: ind 
	"return upper triangle matrix"

	^
	[self isUpper
		ifTrue: 
			[ind <= 0 
				ifTrue: [self]
				ifFalse: 
					[| b offset |
					offset := ind * nrow.
					b := self class triangularMatrix nrow: nrow ncol: ncol.
					b beUpper.
					self lapackInterface 
						lacpyWithuplo: self lapackInterface upper
						m: nrow - ind
						n: ncol - ind
						a: (self arrayPointerWithOffset: offset)
						lda: nrow
						b: (b arrayPointerWithOffset: offset)
						ldb: b nrow.
					b]]
		ifFalse: 
			[ind = 0 
				ifTrue: 
					[| b |
					b := self class triangularMatrix nrow: nrow ncol: ncol.
					b beUpper.
					b setDiagonal: self diagonal.
					b]
				ifFalse: [self zero]]] 
			on: Error
			do: [:exc | exc return: (super upperTriangle: ind)]! !

LapackUnpackedTriangularMatrix subclass: #LapackZTRMatrix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallapack-Matrix'!

!LapackZTRMatrix commentStamp: '<historical>' prior: 0!
LapackZTRMatrix handles Triangular matrices composed of double precision complex numbers
Dense storage is allocated but only half is used.
See superclass for more information.
!

!LapackZTRMatrix class methodsFor: 'class initialization' stamp: ''!
initialize
	self initializeClassInstVars! !

!LapackZTRMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	flags := (FullStorageMask bitOr: TriangularMask) 
				bitOr: (ComplexMask bitOr: DoublePrecisionMask)! !

!LapackMatrix class methodsFor: 'private' stamp: 'nice 2/16/2006 04:39'!
allocateNrow: nr ncol: nc 
	"Allocate the array, but do not initialize its contents"

	^self basicNew 
		setArray: (self smalltalkArrayClass new: nr * nc)
		nrow: nr
		ncol: nc! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
arrayInterface
	^ArrayInterfaces at: self sdczIndex! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
blasInterface
	^BlasInterfaces at: self sdczIndex! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
cArrayClass
	"answer the array suitable for storing data in C space
	can eventually be optimized in subclasses"

	^CArrayClasses at: self sdczIndex! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
columnMatrix
	^self generalMatrix! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:22'!
complexMatrix
	^self findClassWithFlags: (self flags bitOr: ComplexityMask)! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:28'!
diagonalMatrix
	^self 
		findClassWithFlags: ((self flags bitClear: PropertyMask) bitOr: DiagonalMask)! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:22'!
doublePrecisionMatrix
	^self findClassWithFlags: (self flags bitOr: PrecisionMask)! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
eye: anIntegerOrPointOrArrayOfInteger 
	"Create eye matrix. Smae as super but do not initialize the array twice"

	^(self allocateShape: anIntegerOrPointOrArrayOfInteger)
		setToEye;
		yourself! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
findClassWithFlags: someFlags 
	"PrimitiveLapackMatrix 
		allSubclassesDo: [:aClass | aClass flags = someFlags ifTrue: [^aClass]]."

	^FlagsToClassDictionary at: someFlags
		ifAbsent: 
			[self error: 'No Lapack Matrix class were found wih requested properties']! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
flags
	^flags! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
generalMatrix
	^self findClassWithFlags: (self flags bitOr: PropertyMask)! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:28'!
hermitianMatrix
	^self 
		findClassWithFlags: ((self flags bitClear: PropertyMask) bitOr: HermitianMask)! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 2/16/2006 03:18'!
initialize
	"I have to be warned whenever a snapshot is going to take place.
	This is why i register myself as a dependent of ObjectMemory."

	"ObjectMemory
		removeDependent: LapackMatrix;
		addDependent: LapackMatrix."
	self initializeMasks.
	self initializeSeed.
	self initializeArrayClasses.
	self resetBlasInterfaces.
	self resetLapackInterfaces.
	self resetArrayInterfaces! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:22'!
initializeArrayClasses
	"Initialize some variables depending on precision/complexity.
	These variables are to be used with (self sdczIndex) indirection"

	<initialize>
	CArrayClasses := Array new: 4.
	CArrayClasses at: 1 + SinglePrecisionMask + RealMask put: ExternalFloatArray.
	CArrayClasses at: 1 + DoublePrecisionMask + RealMask put: ExternalDoubleArray.
	CArrayClasses at: 1 + SinglePrecisionMask + ComplexMask put: ExternalFloatComplexArray.
	CArrayClasses at: 1 + DoublePrecisionMask + ComplexMask put: ExternalDoubleComplexArray.

"Squeak implementation note: we use the same class to hold either C-space or Smalltalk-space arrays"
	SmalltalkArrayClasses := Array new: 4.
	SmalltalkArrayClasses at: 1 + SinglePrecisionMask + RealMask put: ExternalFloatArray.
	SmalltalkArrayClasses at: 1 + DoublePrecisionMask + RealMask put: ExternalDoubleArray.
	SmalltalkArrayClasses at: 1 + SinglePrecisionMask + ComplexMask put: ExternalFloatComplexArray.
	SmalltalkArrayClasses at: 1 + DoublePrecisionMask + ComplexMask put: ExternalDoubleComplexArray.! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 7/8/2006 01:59'!
initializeBase
	"This is called by subclass initialization.
	This is needed because MC does not initialize superclass first"

	SDCZMask ifNil: [LapackMatrix initialize]! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:37'!
initializeClassInstVars
	self
		initializeBase; "make sure that flags are defined"
		initializeFlags.
	FlagsToClassDictionary at: self flags put: self! !

!LapackMatrix class methodsFor: 'class initialization' stamp: ''!
initializeFlags
	self subclassResponsibility! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:23'!
initializeMasks

	<initialize>
	SDCZMask := 2r11.
	PrecisionMask := 2r1.
	ComplexityMask := 2r10.

	SinglePrecisionMask := 2r0.
	DoublePrecisionMask := 2r1.

	ComplexMask := 2r10.
	RealMask := 2r00.

	PropertyMask := 2r11100.
	GeneralMask := 2r11100.
	TriangularMask := 2r10100.
	HermitianMask := 2r01100.
	DiagonalMask := 2r00100.

	StorageMask := 2r1100000.
	BandStorageMask := 2r1000000.
	FullStorageMask := 2r1100000.
	PackedStorageMask := 2r0100000.

	LowerMask := 2r01.
	UpperMask := 2r10.
	BothUpperLowerMask := 2r11.

	FlagsToClassDictionary := Dictionary new.! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:23'!
initializeSeed
	"This seed is used by LAPACK pseudo random generator
	It must contain four 12bit integers, the last should be even."

	| n |
	<initialize>
	DefaultSeedArray := ShortIntegerArray new: 4.
	n := Time millisecondClockValue.
	1 to: 4
		do: 
			[:i | 
			DefaultSeedArray at: i put: (n \\ (2 raisedTo: 12) bitOr: 1).
			n := n // (2 raisedTo: 12)]! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isBandMatrix
	^(flags bitAnd: StorageMask) = BandStorageMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isComplexMatrix
	^flags allMask: ComplexityMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isDiagonalMatrix
	^(flags bitAnd: PropertyMask) = DiagonalMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isDoublePrecisionMatrix
	^flags allMask: PrecisionMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isFullMatrix
	^(flags bitAnd: StorageMask) = FullStorageMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isGeneralMatrix
	^flags allMask: PropertyMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isHermitianMatrix
	^(flags bitAnd: PropertyMask) = HermitianMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isPackedMatrix
	^(flags bitAnd: StorageMask) = PackedStorageMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isRealMatrix
	^(flags allMask: ComplexityMask) not! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isSinglePrecisionMatrix
	^(flags allMask: PrecisionMask) not! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isSymmetricMatrix
	" we are not interested by Complex Symmetric matrices"

	^self isRealMatrix and: [self isHermitianMatrix]! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isTriangularMatrix
	^(flags bitAnd: PropertyMask) = TriangularMask! !

!LapackMatrix class methodsFor: 'testing' stamp: ''!
isUnpackedMatrix
	^(flags bitAnd: StorageMask) ~= PackedStorageMask! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
lapackInterface
	^LapackInterfaces at: self sdczIndex! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
nrow: nr ncol: nc withAll: aNumber 
	"Create a matrix filled with aNumber"

	^(self allocateNrow: nr ncol: nc) atAllPut: aNumber! !

!LapackMatrix class methodsFor: 'class initialization' stamp: ''!
obsolete
	super obsolete.
	self unregisterFlags! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
packedMatrix
	"This must be overloaded where it make sense"

	^self! !

!LapackMatrix class methodsFor: 'system startup' stamp: ''!
preSnapshot
	"The system is going to snapshot...
	objects pointing onto C heap memory will not survive across the snapshot...
	it is necessary to transfer them in Smalltalk memory before snapshot..."

	self allSubclassesDo: [:subclass | subclass storeInstancesInSmalltalkSpace].! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
randNormal: anIntegerOrPointOrArrayOfInteger 
	"Create a matirx with given shape and initialized randomly (normal distributed mean 0 deviation 1)"

	^(self allocateShape: anIntegerOrPointOrArrayOfInteger)
		fillRandNormal;
		yourself! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
randNormal: anIntegerOrPointOrArrayOfInteger withSeed: seedArray 
	"Create a matirx with given shape and initialized randomly (normal distributed mean 0 deviation 1)"

	^(self allocateShape: anIntegerOrPointOrArrayOfInteger)
		fillRandNormalWithSeed: seedArray;
		yourself! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
randUniform: anIntegerOrPointOrArrayOfInteger 
	"Create a matirx with given shape and initialized randomly (uniform distributed between 0 and 1)"

	^(self allocateShape: anIntegerOrPointOrArrayOfInteger)
		fillRandUniform;
		yourself! !

!LapackMatrix class methodsFor: 'instance creation' stamp: ''!
randUniform: anIntegerOrPointOrArrayOfInteger withSeed: seedArray 
	"Create a matirx with given shape and initialized randomly (uniform distributed between 0 and 1)"

	^(self allocateShape: anIntegerOrPointOrArrayOfInteger)
		fillRandUniformWithSeed: seedArray;
		yourself! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:28'!
realMatrix
	^self findClassWithFlags: (self flags bitClear: ComplexityMask)! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:22'!
resetArrayInterfaces
	<initialize>
	ArrayInterfaces := Array new: 4.
	ArrayInterfaces at: 1 + SinglePrecisionMask + RealMask put: ArraySLibrary new.
	ArrayInterfaces at: 1 + DoublePrecisionMask + RealMask put: ArrayDLibrary new.
	ArrayInterfaces at: 1 + SinglePrecisionMask + ComplexMask put: ArrayCLibrary new.
	ArrayInterfaces at: 1 + DoublePrecisionMask + ComplexMask put: ArrayZLibrary new! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:21'!
resetBlasInterfaces
	<initialize>
	BlasInterfaces := Array new: 4.
	self useCBlas 
		ifTrue: 
			[BlasInterfaces at: 1 + SinglePrecisionMask + RealMask put: CBlasSLibrary new.
			BlasInterfaces at: 1 + DoublePrecisionMask + RealMask put: CBlasDLibrary new.
			BlasInterfaces at: 1 + SinglePrecisionMask + ComplexMask put: CBlasCLibrary new.
			BlasInterfaces at: 1 + DoublePrecisionMask + ComplexMask put: CBlasZLibrary new]
		ifFalse: 
			[BlasInterfaces at: 1 + SinglePrecisionMask + RealMask put: BlasSLibrary new.
			BlasInterfaces at: 1 + DoublePrecisionMask + RealMask put: BlasDLibrary new.
			BlasInterfaces at: 1 + SinglePrecisionMask + ComplexMask put: BlasCLibrary new.
			BlasInterfaces at: 1 + DoublePrecisionMask + ComplexMask put: BlasZLibrary new]! !

!LapackMatrix class methodsFor: 'class initialization' stamp: 'nice 8/4/2011 23:22'!
resetLapackInterfaces
	<initialize>
	LapackInterfaces := Array new: 4.
	self useCLapack
		ifTrue:
			[LapackInterfaces at: 1 + SinglePrecisionMask + RealMask put: CLapackSLibrary new.
			LapackInterfaces at: 1 + DoublePrecisionMask + RealMask put: CLapackDLibrary new.
			LapackInterfaces at: 1 + SinglePrecisionMask + ComplexMask put: CLapackCLibrary new.
			LapackInterfaces at: 1 + DoublePrecisionMask + ComplexMask put: CLapackZLibrary new]
		ifFalse:
			[LapackInterfaces at: 1 + SinglePrecisionMask + RealMask put: LapackSLibrary new.
			LapackInterfaces at: 1 + DoublePrecisionMask + RealMask put: LapackDLibrary new.
			LapackInterfaces at: 1 + SinglePrecisionMask + ComplexMask put: LapackCLibrary new.
			LapackInterfaces at: 1 + DoublePrecisionMask + ComplexMask put: LapackZLibrary new]! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
rowMatrix
	^self generalMatrix! !

!LapackMatrix class methodsFor: 'private' stamp: ''!
sdczIndex
	"Answer an index used for indirection according to precision and complexity"

	^1 + (self flags bitAnd: SDCZMask)! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:29'!
singlePrecisionMatrix
	^self findClassWithFlags: (self flags bitClear: PrecisionMask)! !

!LapackMatrix class methodsFor: 'accessing' stamp: ''!
smalltalkArrayClass
	"answer the array suitable for storing data in Smalltalk space"

	^SmalltalkArrayClasses at: self sdczIndex! !

!LapackMatrix class methodsFor: 'system startup' stamp: ''!
storeInstancesInSmalltalkSpace
	self allInstancesDo: [:e | e storeInSmalltalkSpace]! !

!LapackMatrix class methodsFor: 'converting' stamp: 'nice 5/20/2006 02:29'!
triangularMatrix
	^self 
		findClassWithFlags: ((self flags bitClear: PropertyMask) bitOr: TriangularMask)! !

!LapackMatrix class methodsFor: 'converting' stamp: ''!
unpackedMatrix
	"This must be overloaded where it make sense"

	^self! !

!LapackMatrix class methodsFor: 'class initialization' stamp: ''!
unregisterFlags
	"remove reference to a self before being unloaded"

	FlagsToClassDictionary removeKey: self flags ifAbsent: []! !

!LapackMatrix class methodsFor: 'preferences' stamp: 'nice 8/4/2011 23:17'!
useCBlas
	<preference: 'Whether to use the CBlas version or a traditional FORTRAN Blas'
	category: 'Smallapack'
	description: 'If true the CBlas version will be used. This version pass arguments by value when possible.'
	type: #Boolean>
	^UseCBlas ifNil: [ true ]

	! !

!LapackMatrix class methodsFor: 'preferences' stamp: 'nice 8/4/2011 23:17'!
useCBlas: aBoolean
	UseCBlas := aBoolean.
	self resetBlasInterfaces
	! !

!LapackMatrix class methodsFor: 'preferences' stamp: 'nice 8/4/2011 23:18'!
useCLapack
	<preference: 'Whether to use the CLapack version or a traditional FORTRAN Lapack'
	category: 'Smallapack'
	description: 'If true the CLapack version will be used. This version pass arguments by value when possible.'
	type: #Boolean>
	^UseCLapack ifNil: [ true ]

	! !

!LapackMatrix class methodsFor: 'preferences' stamp: 'nice 8/4/2011 23:19'!
useCLapack: aBoolean
	UseCLapack := aBoolean.
	self resetLapackInterfaces
	! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
* aMatrix
	^aMatrix productFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
+ aMatrix
	^aMatrix sumFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'concatenating' stamp: ''!
, aMatrix 
	^aMatrix concatColumnsFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'concatenating' stamp: ''!
,, aMatrix 
	^aMatrix concatRowsFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
- aMatrix
	^aMatrix differenceFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
/ aMatrix
	^aMatrix quotientFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
\ aMatrix
	^aMatrix leftDivideFromLapackMatrix: self! !

!LapackMatrix methodsFor: 'norm' stamp: ''!
absMax
	^self class isGeneralMatrix 
		ifTrue: [super absMax]
		ifFalse: [self asGeneralMatrix absMax]! !

!LapackMatrix methodsFor: 'private' stamp: ''!
arrayPointer
	"Answer a pointer on an array directly usable in C primitives..."

	^self cArray arrayPointer! !

!LapackMatrix methodsFor: 'private' stamp: 'nice 5/17/2006 22:37'!
arrayPointerWithOffset: anOffset
	"Answer a pointer on an array directly usable in C primitives...
	The offset is given in number of elements, not in bytes."

	^(self cArray withArrayOffsetBy: anOffset) arrayPointer! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 5/17/2006 23:32'!
asAbstractMatrix
	^ AbstractMatrix basicNew
		setArray: (self isInCSpace
				ifTrue: [array copyInSmalltalkSpace]
				ifFalse: [array copy])
		nrow: nrow
		ncol: ncol! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asColumnMatrix
	^ncol = 1 
		ifTrue: [self]
		ifFalse: 
			[| res |
			res := self class nrow: self size.
			res 
				copy: self size
				elementsFrom: self
				sourceIncrement: 1
				destIncrement: 1]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asComplexMatrix
	^self class isComplexMatrix 
		ifTrue: [self]
		ifFalse: [self coerceToComplexMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asDoublePrecisionComplexMatrix
	^self class isDoublePrecisionMatrix 
		ifTrue: [self asComplexMatrix]
		ifFalse: [self coerceToDoublePrecisionComplexMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asDoublePrecisionMatrix
	^self class isDoublePrecisionMatrix 
		ifTrue: [self]
		ifFalse: [self coerceToDoublePrecisionMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asGeneralMatrix
	^self class isGeneralMatrix 
		ifTrue: [self]
		ifFalse: [self coerceToGeneralMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asPackedMatrix
	"Implementation notes: this does not make much sense for general matrix.
	But this work as a stub. Should be overloaded in subclasses where it make sense."

	^self! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asRowMatrix
	^nrow = 1 
		ifTrue: [self]
		ifFalse: 
			[| res |
			res := self class ncol: self size.
			res 
				copy: self size
				elementsFrom: self
				sourceIncrement: 1
				destIncrement: 1]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asSinglePrecisionComplexMatrix
	^self class isSinglePrecisionMatrix 
		ifTrue: [self asComplexMatrix]
		ifFalse: [self coerceToSinglePrecisionComplexMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asSinglePrecisionMatrix
	^self class isSinglePrecisionMatrix 
		ifTrue: [self]
		ifFalse: [self coerceToSinglePrecisionMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
asUnpackedMatrix
	"Default for LapackMatrices is to be unpacked, return self.
	This message should be overloaded in subclass where it make sense"

	^self! !

!LapackMatrix methodsFor: 'accessing' stamp: 'nice 5/23/2006 23:34'!
at: anInteger put: aNumber 
	"This method does handle error due to impossible conversion"

	^self 
		at: anInteger
		put: aNumber
		handle: 
			[:exc | 
			exc return: (aNumber coercing: self
						do: 
							[:num :mat | 
							(mat == self ifTrue: [self] ifFalse: [self become: mat])
								arrayAt: anInteger put: num;
								yourself])]! !

!LapackMatrix methodsFor: 'accessing' stamp: 'nice 5/23/2006 23:33'!
at: anInteger put: aNumber handle: exceptionBlock 
	"This method does handle error due to	impossible conversion"
	
	^ [array at: anInteger put: aNumber]
		on: Error
		do: [:ex | (anInteger between: 1 and: array size)
				ifTrue: [exceptionBlock value: ex]
				ifFalse: [ex pass]]! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
atAllPut: aNumber 
	self setOffDiagonal: aNumber diagonal: aNumber! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
atIntervalFrom: interStart to: interStop by: interStep 
	"fast method : bounds checking must be done externally"

	| sz |
	sz := (interStop - interStart) // interStep + 1.
	^(nrow = 1 
		ifTrue: [self class allocateNrow: 1 ncol: sz]
		ifFalse: [self class allocateNrow: sz ncol: 1]) 
			copy: sz
			elementsFrom: self
			sourceOffset: (interStep positive ifTrue: [interStart] ifFalse: [interStart + ((sz - 1) * interStep)]) - 1
			sourceIncrement: interStep
			destOffset: 0
			destIncrement: 1! !

!LapackMatrix methodsFor: 'private' stamp: ''!
blasInterface
	^self class blasInterface! !

!LapackMatrix methodsFor: 'private' stamp: ''!
cArray
	"Make sure the array is member of CArrayAccessor,
	and answer this array.
	This transfer is needed before calling an external library... "


	| theArray cArray  |

	"Implementation Note: this is an atomic multi thread safe implementation
	use a temporary theArray, do not use inst.var. array, nor other isInCSpace utility function
	because it might have changed before return in a mult-threaded environment"
	^(theArray := array) class == self class cArrayClass 
		ifTrue: [theArray]
		ifFalse: 
			[theArray class = self class smalltalkArrayClass 
				ifTrue: 
					["we can use optimized primitive in this case"

					cArray := self class cArrayClass new: theArray size.
					cArray arrayPointer 
						copyAt: 0
						from: theArray
						size: theArray basicSize
						startingAt: 1]
				ifFalse: 
					["one did not use the optimized smalltalkArrayClass
					Fall back to slower elementwise copy"

					cArray := self class cArrayClass withAll: theArray].
			array := cArray]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
castTo: aMatrixClass 
	"Answer a Matrix sharing the same array and that can be used in place of me.

	This should not be used to cast type (real/complex) or precision (single/double),
	because the underlying arrays will not be compatible.
	This can be used only to cast the properties.

	This message avoids a copy and is efficient, but should be used with care.
	It is as ugly as a C-code cast"

	^aMatrixClass basicNew 
		setArray: self cArray
		nrow: nrow
		ncol: ncol! !

!LapackMatrix methodsFor: 'private' stamp: ''!
castToColumn
	^self class generalMatrix basicNew 
		setArray: array
		nrow: self arraySize
		ncol: 1! !

!LapackMatrix methodsFor: 'private' stamp: ''!
castToRealWithArrayOffsetBy: aPositiveInteger 
	"Return a kind of shallow copy of self pointing on the same C underlying object, but as if it was a sequence of reals with an offset.
	This is ugly like C code but maybe more efficient"

	^self isComplexMatrix 
		ifTrue: 
			[| castToReal |
			castToReal := self cArray castToRealWithArrayOffsetBy: aPositiveInteger.
			self class realMatrix generalMatrix basicNew 
				setArray: castToReal
				nrow: castToReal size
				ncol: 1]
		ifFalse: [self withArrayOffsetBy: aPositiveInteger]! !

!LapackMatrix methodsFor: 'private' stamp: ''!
castToRow
	^self class generalMatrix basicNew 
		setArray: array
		nrow: 1
		ncol: self arraySize! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceFlags: destFlags 
	| flags m |
	(flags := self class flags) = destFlags ifTrue: [^self].
	m := self.
	(flags bitAnd: PropertyMask) = (destFlags bitAnd: PropertyMask) 
		ifFalse: 
			[m := m asGeneralMatrix.
			flags := m class flags].
	(flags bitAnd: ComplexityMask) = (destFlags bitAnd: ComplexityMask) 
		ifFalse: 
			[m := m asComplexMatrix.
			flags := m class flags].
	(flags bitAnd: PrecisionMask) = (destFlags bitAnd: PrecisionMask) 
		ifFalse: 
			[m := m asDoublePrecisionMatrix.
			flags := m class flags].
	^m! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceFlagsButProperty: destFlags 
	| flags m |
	(flags := self class flags) = destFlags ifTrue: [^self].
	m := self.
	(flags bitAnd: ComplexityMask) = (destFlags bitAnd: ComplexityMask) 
		ifFalse: 
			[m := m asComplexMatrix.
			flags := m class flags].
	(flags bitAnd: PrecisionMask) = (destFlags bitAnd: PrecisionMask) 
		ifFalse: 
			[m := m asDoublePrecisionMatrix.
			flags := m class flags].
	^m! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceToComplexMatrix
	"Fast implementation: copy every two reals"

	| dst src |
	dst := self class complexMatrix nrow: nrow ncol: ncol.
	src := self withArrayOffsetBy: 0.
	(dst castToRealWithArrayOffsetBy: 0) 
		copy: src arraySize
		elementsFrom: src
		sourceIncrement: 1
		destIncrement: 2.
	^dst! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceToDoublePrecisionComplexMatrix
	"SLOW naive implementation"

	| res |
	res := self class doublePrecisionMatrix complexMatrix allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (self rowAt: ir columnAt: jc) asDoubleComplex]].
	^res! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 5/21/2006 02:22'!
coerceToDoublePrecisionMatrix
	"Try FAST primitive and if fail revert to SLOW naive implementation"

	^
	[| res |
	res := self class doublePrecisionMatrix allocateNrow: nrow ncol: ncol.
	res class isComplexMatrix 
		ifTrue: 
			[self class realMatrix arrayInterface 
				arraystodWithn: self arraySize * 2
				source: (self cArray castToRealWithArrayOffsetBy: 0) arrayPointer
				result: (res cArray castToRealWithArrayOffsetBy: 0) arrayPointer]
		ifFalse: 
			[self class arrayInterface 
				arraystodWithn: self arraySize
				source: self arrayPointer
				result: res arrayPointer].
	res] 
			on: Error
			do: [:exc | exc return: self naiveCoerceToDoublePrecisionMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceToGeneralMatrix
	"SLOW naive implementation"

	| res |
	res := self class generalMatrix allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (self rowAt: ir columnAt: jc)]].
	^res! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coerceToSinglePrecisionComplexMatrix
	"SLOW naive implementation"

	| res |
	res := self class singlePrecisionMatrix complexMatrix allocateNrow: nrow ncol: ncol.
	1 to: ncol
		do: 
			[:jc | 
			1 to: nrow
				do: 
					[:ir | 
					res 
						rowAt: ir
						columnAt: jc
						put: (self rowAt: ir columnAt: jc) asFloatComplex]].
	^res! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 5/21/2006 02:22'!
coerceToSinglePrecisionMatrix
	"Try FAST primitive and if fail revert to SLOW naive implementation"

	^
	[| res |
	res := self class singlePrecisionMatrix allocateNrow: nrow ncol: ncol.
	res class isComplexMatrix 
		ifTrue: 
			[self class realMatrix arrayInterface 
				arraydtosWithn: self arraySize * 2
				source: (self cArray castToRealWithArrayOffsetBy: 0) arrayPointer
				result: (res cArray castToRealWithArrayOffsetBy: 0) arrayPointer]
		ifFalse: 
			[self class arrayInterface 
				arraydtosWithn: self arraySize
				source: self arrayPointer
				result: res arrayPointer].
	res] 
			on: Error
			do: [:exc | exc return: self naiveCoerceToSinglePrecisionMatrix]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coercing: aMatrix do: aBlock 
	^aMatrix coercingFromLapackMatrix: self do: aBlock! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coercingButPropertyFromLapackMatrix: aLapackMatrix do: aBlock 
	"Convert self and aLapackMatrix to a minimum generality common Matrix class.
	Resulting matrices can have different property flags
	Do a cheap test on class first in order to handle fast what should be the more frequent case
	Then evaluate aBlock with: aLapackMatrix with: self in that order"

	^aLapackMatrix class = self class 
		ifTrue: [self postCoercingFromLapackMatrix: aLapackMatrix do: aBlock]
		ifFalse: 
			[| resultFlags |
			resultFlags := aLapackMatrix class flags bitOr: self class flags.
			(self coerceFlagsButProperty: resultFlags) 
				postCoercingFromLapackMatrix: (aLapackMatrix coerceFlagsButProperty: resultFlags)
				do: aBlock]! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:03'!
coercingFromComplexNumber: aComplex do: aBlock 
	^aBlock value: aComplex
		value: self asComplexMatrix! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
coercingFromLapackMatrix: aLapackMatrix do: aBlock 
	"Convert self and aMatrix to a minimum generality common Matrix class.
	Do a cheap test on class first in order to handle fast what should be the more frequent case
	Then evaluate aBlock with: aLapackMatrix with: self in that order"

	^aLapackMatrix class = self class 
		ifTrue: [self postCoercingFromLapackMatrix: aLapackMatrix do: aBlock]
		ifFalse: 
			[| resultFlags |
			resultFlags := aLapackMatrix class flags bitOr: self class flags.
			(self coerceFlags: resultFlags) 
				postCoercingFromLapackMatrix: (aLapackMatrix coerceFlags: resultFlags)
				do: aBlock]! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:05'!
coercingFromNumber: aNumber do: aBlock 
	^aNumber asFloat coercing: self do: aBlock! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 2/16/2006 04:04'!
coercingFromRealNumber: aFloat do: aBlock 
	^aBlock value: (self class isComplexMatrix 
				ifTrue:  [aFloat asComplex]
				ifFalse: [aFloat])
		value: self! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
concatColumnsFromLapackMatrix: aLapackMatrix
	"Answer a Matrix whose columns are those of a aLapackMatrix concatenated with selve's.
	Must first coerce matrices to same class"

	^self coercingFromLapackMatrix: aLapackMatrix do: [:a :b | a concatColumnsWithLapackMatrix: b]! !

!LapackMatrix methodsFor: 'concatenating' stamp: ''!
concatColumnsWithLapackMatrix: aMatrix 
	"we know that aMatrix and self have same class
	use blas primitive to do the job"

	| res |
	self size = 0 ifTrue: [^aMatrix copy].
	aMatrix size = 0 ifTrue: [^self copy].
	aMatrix nrow = nrow 
		ifFalse: [self error: 'cannot concatenate columns if not same number of rows'].
	res := self class allocateNrow: nrow ncol: ncol + aMatrix ncol.
	res 
		copy: self size
		elementsFrom: self
		sourceIncrement: 1
		destIncrement: 1.
	res 
		copy: aMatrix size
		elementsFrom: aMatrix
		sourceOffset: 0
		sourceIncrement: 1
		destOffset: self size
		destIncrement: 1.
	^res! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
concatRowsFromLapackMatrix: aLapackMatrix
	"Answer a Matrix whose rows are those of a aLapackMatrix concatenated with selve's.
	Must first coerce matrices to same class"

	^self coercingFromLapackMatrix: aLapackMatrix do: [:a :b | a concatRowsWithLapackMatrix: b]! !

!LapackMatrix methodsFor: 'concatenating' stamp: ''!
concatRowsWithLapackMatrix: aMatrix 
	"we know that aMatrix and self have same class
	use lapack primitive to do the job"

	| res |
	self size = 0 ifTrue: [^aMatrix copy].
	aMatrix size = 0 ifTrue: [^self copy].
	aMatrix ncol = ncol 
		ifFalse: [self error: 'cannot concatenate rows if not same number of columns'].
	res := self class allocateNrow: nrow + aMatrix nrow ncol: ncol.
	res 
		copy: nrow
		rowsStartingAt: 1
		and: ncol
		columnsStartingAt: 1
		from: self.
	res 
		copy: aMatrix nrow
		rowsStartingAt: nrow + 1
		and: ncol
		columnsStartingAt: 1
		from: aMatrix.
	^res! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 5/21/2006 02:22'!
conjugated
	"Try lapack or revert to super slow naive implementation.
	Note: this should also work with packed forms thanks to arraySize"

	^self class isComplexMatrix 
		ifTrue: 
			[
			[| res |
			res := self copy.
			self lapackInterface 
				lacgvWithn: self arraySize
				x: res arrayPointer
				incx: 1.
			res] 
					on: Error
					do: [:exc | exc return: super conjugated]]
		ifFalse: [self]! !

!LapackMatrix methodsFor: 'copying' stamp: ''!
copy
	"Implementation notes: this code should be more efficient than doing the super postCopy (array := array copy)
	postCopy must be overloaded to just create the array"

	^super copy 
		copy: self arraySize
		elementsFrom: self
		sourceIncrement: 1
		destIncrement: 1! !

!LapackMatrix methodsFor: 'private-blas' stamp: 'nice 3/20/2007 00:47'!
copy: n elementsFrom: aLapackMatrix sourceOffset: offx sourceIncrement: incx destOffset: offy destIncrement: incy 
	(offx >= 0 and: [n - 1 * incx abs + offx < aLapackMatrix size]) 
		ifFalse: [^self error: 'matrix access out of bounds'].
	(offy >= 0 and: [n - 1 * incy abs + offy < self size]) 
		ifFalse: [^self error: 'matrix access out of bounds'].
	
	[self blasInterface 
		copyWithN: n
		X: (aLapackMatrix arrayPointerWithOffset: offx)
		incX: incx
		Y: (self arrayPointerWithOffset: offy)
		incY: incy] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							copy: n
							elementsFrom: aLapackMatrix
							sourceOffset: offx
							sourceIncrement: incx
							destOffset: offy
							destIncrement: incy)]! !

!LapackMatrix methodsFor: 'private-lapack' stamp: 'nice 5/21/2006 02:22'!
copy: m rowsStartingAt: ir and: n columnsStartingAt: jc from: a 
	
	[self lapackInterface 
		lacpyWithuplo: self lapackInterface notTransposed
		m: m
		n: n
		a: a arrayPointer
		lda: a nrow
		b: (self arrayPointerWithOffset: (self arrayOffsetAtRow: ir atColumn: jc))
		ldb: nrow] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							copy: m
							rowsStartingAt: ir
							and: n
							columnsStartingAt: jc
							from: a)]! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
defaultTolerance
	"Answer a tolerance used by default for several algorithm"

	^(nrow max: ncol) * self norm2 * self lapackInterface eps! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
determinant
	nrow = ncol ifFalse: [self error: 'should be square'].
	^self pluDecomposition determinant! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
differenceFromLapackMatrix: aLapackMatrix 
	(aLapackMatrix nrow = nrow and: [aLapackMatrix ncol = ncol]) 
		ifFalse: [self error: 'unconsistent matrix dimensions'].
	^self coercingFromLapackMatrix: aLapackMatrix do: [:a :b | a differenceWithLapackMatrix: b]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
differenceWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class
	use BLAS xAXPY (aMatrix * -1 + self)"

	| res |
	res := self copy.
	res 
		fill: self arraySize
		elementsWithStride: 1
		withSelfPlusScalar: -1
		timesVector: aLapackMatrix
		stride: 1.
	^res! !

!LapackMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:23'!
dotProduct: n elementsIncrement: incx with: aMatrix increment: incy 
	
	^[self blasInterface 
		dotWithN: n
		X: self arrayPointer
		incX: incx
		Y: aMatrix arrayPointer
		incY: incy] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							dotProduct: n
							elementsIncrement: incx
							with: aMatrix
							increment: incy)]! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
eigenValueDecomposition
	^self asGeneralMatrix eigenValueDecomposition! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
eigenValues
	^(self eigenValueDecomposition)
		wantLeftEigenVectors: false;
		wantRightEigenVectors: false;
		eigenValues! !

!LapackMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:23'!
fill: n elementsWithStride: incy withSelfPlusScalar: alpha timesVector: aMatrix stride: incx 
	"Fill n elements of self with a Scalar*Vector product
		alpha*aMatrix + self
	This is the xAXPY BLAS operation"

	
	[self blasInterface 
		axpyWithN: n
		alpha: alpha
		X: aMatrix arrayPointer
		incX: incx
		Y: self arrayPointer
		incY: incy] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							fill: n
							elementsWithStride: incy
							withSelfPlusScalar: alpha
							timesVector: aMatrix
							stride: incx)]! !

!LapackMatrix methodsFor: 'private-blas' stamp: 'nice 5/21/2006 02:23'!
fillM: m byN: n withScalar: alpha timesColumnVector: x stride: incx timesRowVector: y stride: incy 
	"fill self with a Vector*transpose(Vector) product
		alpha*x*transpose(y)"
 
	[self blasInterface 
		gerWithM: m
		N: n
		alpha: alpha
		X: x arrayPointer
		incX: incx
		Y: y arrayPointer
		incY: incy
		A: self arrayPointer
		lda: nrow] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							fillM: m
							byN: n
							withScalar: alpha
							timesColumnVector: x
							stride: incx
							timesRowVector: y
							stride: incy)]! !

!LapackMatrix methodsFor: 'initialize-release' stamp: ''!
fillRandNormal
	^self fillRandNormalWithSeed: DefaultSeedArray! !

!LapackMatrix methodsFor: 'initialize-release' stamp: 'nice 5/21/2006 00:22'!
fillRandNormalWithSeed: seedArray 
	"On return, the seed array is changed"

	| directAccess iseed |
	directAccess := seedArray class = WordArray and: 
					[seedArray size = 4].
	directAccess 
		ifTrue: [iseed := seedArray]
		ifFalse: 
			[(iseed := WordArray new: 4) 
				replaceFrom: 1
				to: 4
				with: seedArray].
	self lapackInterface 
		larnvWithidist: self lapackInterface normal01
		iseed: iseed "arrayPointer"
		n: self arraySize
		x: self arrayPointer.
	directAccess 
		ifFalse: 
			[seedArray 
				replaceFrom: 1
				to: 4
				with: iseed]! !

!LapackMatrix methodsFor: 'initialize-release' stamp: ''!
fillRandUniform
	^self fillRandUniformWithSeed: DefaultSeedArray! !

!LapackMatrix methodsFor: 'initialize-release' stamp: 'nice 5/25/2006 00:18'!
fillRandUniformWithSeed: seedArray 
	"On return, the seed array is changed"

	| directAccess iseed |
	directAccess := seedArray class = WordArray and: 
					[seedArray size = 4].
	directAccess 
		ifTrue: [iseed := seedArray]
		ifFalse: 
			[(iseed := WordArray new: 4) 
				replaceFrom: 1
				to: 4
				with: seedArray].
	self lapackInterface 
		larnvWithidist: self lapackInterface uniform01
		iseed: iseed "arrayPointer"
		n: self arraySize
		x: self arrayPointer.
	directAccess 
		ifFalse: 
			[seedArray 
				replaceFrom: 1
				to: 4
				with: iseed]! !

!LapackMatrix methodsFor: 'private-lapack' stamp: 'nice 5/21/2006 02:23'!
fromColumn: jStart toColumn: jStop by: jStep 
	"Trick: use lapack auxiliary matrix copy with leading dimension augmented"

	jStep positive 
		ifFalse: 
			[^super 
				fromColumn: jStart
				toColumn: jStop
				by: jStep].
	^
	[| nc res |
	nc := (jStart to: jStop by: jStep) size.
	res := self class allocateNrow: nrow ncol: nc.
	self lapackInterface 
		lacpyWithuplo: self lapackInterface notTransposed
		m: nrow
		n: nc
		a: (self arrayPointerWithOffset: (jStart - 1) * nrow)
		lda: nrow * jStep
		b: res arrayPointer
		ldb: nrow.
	res] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(super 
							fromColumn: jStart
							toColumn: jStop
							by: jStep)]! !

!LapackMatrix methodsFor: 'decomposition' stamp: 'nice 2/20/2009 02:03'!
generalizedEigenValueDecompositionWithRHSMatrix: aMatrix 
	"solve a generalized eigenvalue problem"

	^self asGeneralMatrix 
		generalizedEigenValueDecompositionWithRHSMatrix: aMatrix! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
hessenbergDecomposition
	"hessenberg decomposition"

	nrow = ncol 
		ifFalse: 
			[^self error: 'hessenberg decomposition apply only on square Matrices'].
	^LapackHessenbergDecomposition decompose: self asGeneralMatrix! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
imaginaryPart
	"Fast implementation: copy every two reals"

	^self class isComplexMatrix 
		ifTrue: 
			[| res |
			((res := self class realMatrix nrow: nrow ncol: ncol) withArrayOffsetBy: 0) 
				copy: self arraySize
				elementsFrom: (self castToRealWithArrayOffsetBy: 1)
				sourceIncrement: 2
				destIncrement: 1.
			res]
		ifFalse: [self zero]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: 'nice 6/21/2010 23:54'!
inPlaceScaledByComplex: aComplex 
	"Scale self in place (modify self, not a copy).
	aComplex and self should agree on precision before sending this message."

	
	[self blasInterface 
		scalWithN: self arraySize
		alpha: aComplex
		X: self arrayPointer
		incX: 1] 
			on: Error
			do: 
				[:exc | 
				exc retryUsing: 
						[self 
							scale: self size
							elementsBy: aComplex
							increment: 1]]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: 'nice 5/21/2006 02:24'!
inPlaceScaledByNumber: aNumber 
	"Scale self in place (modify self, not a copy).
	aNumber and self should agree on precision before sending this message."

	
	[self class isComplexMatrix 
		ifTrue: 
			[self blasInterface 
				realScalWithN: self arraySize
				alpha: aNumber
				X: self arrayPointer
				incX: 1]
		ifFalse: 
			[self blasInterface 
				scalWithN: self arraySize
				alpha: aNumber
				X: self arrayPointer
				incX: 1]] 
			on: Error
			do: 
				[:exc | 
				exc return: 
						(self 
							scale: self size
							elementsBy: aNumber
							increment: 1)]! !

!LapackMatrix methodsFor: 'private' stamp: 'nice 5/20/2006 02:59'!
inPlaceSolve: b 
	"find x such that self*x=b, that is solve a linear system of equations
	BEWARE: this will destroy matrices self and b
	on return:
		x is stored in b on return
		self contains L and U of P*L*U decomposition (diagonal 1 of L not included)
		ipiv contains permutations of rows P of P*L*U decomposition
		info contains error code if not 0"

	| ipiv info |
	ipiv := ExternalLongArray new: nrow.
	info := self lapackInterface 
				gesvWithn: nrow
				nrhs: b ncol
				a: self arrayPointer
				lda: nrow
				ipiv: ipiv arrayPointer
				b: b arrayPointer
				ldb: b nrow.
	info = 0 ifFalse: [self error: 'inversion failed'].
	^b! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isBandMatrix
	^self class isBandMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isComplexMatrix
	^self class isComplexMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isDiagonalMatrix
	^self class isDiagonalMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isDoublePrecisionMatrix
	^self class isDoublePrecisionMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isGeneralMatrix
	^self class isGeneralMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isHermitianMatrix
	^self class isHermitianMatrix! !

!LapackMatrix methodsFor: 'private' stamp: ''!
isInCSpace
	^array class == self class cArrayClass! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isPackedMatrix
	^self class isPackedMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isRealMatrix
	^self class isRealMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isSinglePrecisionMatrix
	^self class isSinglePrecisionMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isSymmetricMatrix
	^self class isSymmetricMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isTriangularMatrix
	^self class isTriangularMatrix! !

!LapackMatrix methodsFor: 'testing' stamp: ''!
isUnpackedMatrix
	^self class isUnpackedMatrix! !

!LapackMatrix methodsFor: 'private' stamp: ''!
lapackInterface
	^self class lapackInterface! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
leftDivideFromLapackMatrix: aLapackMatrix 
	"More or less equivalent to :
		aLapackMatrixf pseudoInverse * sel"

	aLapackMatrix ncol = ncol 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	^(self coercingButPropertyFromLapackMatrix: aLapackMatrix
				do: [:a :b | a leftDivideWithLapackMatrix: b])! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
leftDivideWithLapackMatrix: aLapackMatrix 
	"Answer the result of division
		self \ aLapackMatrix
	NAIVE implementation.
	Should be coded more efficiently with direct DGESV or DGELSS calls ..."

	^self isSquare 
		ifTrue: [self reciprocal * aLapackMatrix]
		ifFalse: 
			["self pseudoInverse * aLapackMatrix"

			| solver |
			solver := LapackLeastSquareProblem new matrix: self asGeneralMatrix
						rhsMatrix: aLapackMatrix asGeneralMatrix.
			solver solution]! !

!LapackMatrix methodsFor: 'converting' stamp: 'nice 5/15/2006 23:02'!
naiveCoerceToDoublePrecisionMatrix
	"SLOW naive implementation"

	| res |
	res := self class doublePrecisionMatrix allocateNrow: nrow ncol: ncol.
	res class isComplexMatrix 
		ifTrue: 
			[1 to: ncol do: [:jc | 
					1 to: nrow do: [:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: (self rowAt: ir columnAt: jc) asFloatComplex]]]
		ifFalse: 
			[1 to: ncol do: [:jc | 
					1 to: nrow do: [:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: (self rowAt: ir columnAt: jc) asFloat]]].
	^res! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
naiveCoerceToSinglePrecisionMatrix
	"SLOW naive implementation"

	| res |
	res := self class singlePrecisionMatrix allocateNrow: nrow ncol: ncol.
	res class isComplexMatrix 
		ifTrue: 
			[1 to: ncol do: [:jc | 
					1 to: nrow do: [:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: (self rowAt: ir columnAt: jc) asFloatComplex]]]
		ifFalse: 
			[1 to: ncol do: [:jc | 
					1 to: nrow do: [:ir | 
							res 
								rowAt: ir
								columnAt: jc
								put: (self rowAt: ir columnAt: jc) asFloat]]].
	^res! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
negated
	^self scaledByNumber: -1! !

!LapackMatrix methodsFor: 'norm' stamp: ''!
norm1
	^self class isGeneralMatrix 
		ifTrue: [super norm1]
		ifFalse: [self asGeneralMatrix norm1]! !

!LapackMatrix methodsFor: 'norm' stamp: ''!
normFrobenius
	^self class isGeneralMatrix 
		ifTrue: [super normFrobenius]
		ifFalse: [self asGeneralMatrix normFrobenius]! !

!LapackMatrix methodsFor: 'norm' stamp: ''!
normInfinity
	^self class isGeneralMatrix 
		ifTrue: [super normInfinity]
		ifFalse: [self asGeneralMatrix normInfinity]! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
pluDecomposition
	^self asGeneralMatrix pluDecomposition! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
postCoercingFromLapackMatrix: aLapackMatrix do: aBlock 
	"Default implementation is to evaluate a block.
	Some subclasses might have to perform further checking (like uplo conformance)"

	^aBlock value: aLapackMatrix value: self! !

!LapackMatrix methodsFor: 'copying' stamp: ''!
postCopy
	"Implementation notes: only allocate here,
	DO NOT COPY THE ARRAY AT THIS LEVEL
	(hence do NOT call super postCopy)
	
	copy will actually do the copy of array contents with optimized BLAS"

	array := array class new: array size.! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
productColumnVectorWithRowVector: aLapackMatrix 
	"We know that aPrimitiveMatrix has a compatible class with self
	Branch on more efficient BLAS routine according to dimensions"

	| res |
	res := self class generalMatrix nrow: nrow ncol: aLapackMatrix ncol.
	res 
		fillM: nrow
		byN: aLapackMatrix ncol
		withScalar: 1
		timesColumnVector: self
		stride: 1
		timesRowVector: aLapackMatrix
		stride: 1.
	^res! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromComplex: aComplex 
	^aComplex coercing: self do: [:num :mat | mat scaledByComplex: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromDouble: aDouble 
	^aDouble coercing: self do: [:num :mat | mat scaledByNumber: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFixedPoint: aFixedPoint 
	^aFixedPoint asLimitedPrecisionReal coercing: self
		do: [:num :mat | mat scaledByNumber: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFloat: aFloat 
	^aFloat coercing: self do: [:num :mat | mat scaledByNumber: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromFraction: aFraction 
	^aFraction asLimitedPrecisionReal coercing: self
		do: [:num :mat | mat scaledByNumber: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromInteger: anInteger 
	^anInteger asLimitedPrecisionReal coercing: self
		do: [:num :mat | mat scaledByNumber: num]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
productFromLapackMatrix: aLapackMatrix 
	"Answer the result of matrix product
		aLapackMatrix * self
	Implementation Notes: 
	1) Do not coerce the properties (Hermitian, Triangular, ...)
	   because LAPACK/BLAS functions will handle heterogeneous case.
	   (as Matrix*Vector for example)
	2) Dimension testing is done here only.
	   Won't be done in lower #product* methods"

	aLapackMatrix ncol = nrow 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	^self coercingButPropertyFromLapackMatrix: aLapackMatrix
		do: [:a :b | a productWithLapackMatrix: b]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: 'nice 8/4/2011 23:32'!
productRowVectorWithColumnVector: aLapackMatrix 
	"Implementation notes:
	We must not use DOT in complex case because BLAS return a complex by value,
	and VW Smalltalk does not seem to handle the case correctly (at least with g77)"

	| res |
	res := self class nrow: 1 ncol: 1.
	(self isComplexMatrix not or: [self class useCBlas]) 
		ifTrue: 
			["Case when we can use DOT"

			| dotProduct |
			dotProduct := self 
						dotProduct: self size
						elementsIncrement: 1
						with: aLapackMatrix
						increment: 1.
			res at: 1 put: dotProduct]
		ifFalse: 
			["Fall back to matrix*vector product"

			self productMatrixWithColumnVector: aLapackMatrix].
	^res! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
productRowVectorWithMatrix: aMatrix 
	"Vector * Matrix
	naive algorithm"

	^aMatrix productMatrixTransposeWithColumnVector: self asColumnMatrix! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
productWithLapackMatrix: aLapackMatrix 
	"We know that aLapackMatrix has a compatible class with self
	(in term of complexity and precision)
	Branch on more efficient BLAS routine according to dimensions

	Implementation notes:
	BLAS give functions for multiplying Matrix*Matrix :
	- HE * GE or GE * HE
	- SY * GE or GE * SY
	- TR * GE or GE * TR
	- GE * GE
	Then, one of the two matrices will be considered as General and have all elements accessed (full storage).
	In case of triangular Matrix, the other triangle is always set to zero (by construction)
	In case of symmetric/hermitian Matrix, this should be asserted using message #fillOtherTriangle.

	Note: there is no HP * GE nor SP * GE nor TP * GE BLAS routine. We have to use unpacked forms.

	BECAUSE LapackHermitianMatrix has the lowest propertyFlags,
	GeneralMask > TriangularMask > HermitianMask
	then a Matrix*Matrix product involving a Symmetric/Hermitian Matrix
	will always perform a message with a LapackHermitianMatrix receiver.
	Thus the fillOtherTriangle operation need only be handled in LapackHermitianMatrix subclass

	This trick will not work if one changes property ordering.
	
	When adding a new subclass, one should consider rewriting this code.
	In particular, something is needed for band matrices"

	^aLapackMatrix isColumnVector 
		ifTrue: 
			[self isRowVector 
				ifTrue: 
					["Case (1,n)*(n,1)"

					self productRowVectorWithColumnVector: aLapackMatrix]
				ifFalse: 
					["Case (m,n)*(n,1)"

					self productMatrixWithColumnVector: aLapackMatrix]]
		ifFalse: 
			[self isColumnVector 
				ifTrue: 
					["Case (m,1)*(1,n)"

					self productColumnVectorWithRowVector: aLapackMatrix]
				ifFalse: 
					[self isRowVector 
						ifTrue: 
							["Case (1,m)*(m,n) : transpose the product
							with a little trick to save a copy : use self castToCulumn instead of self transposed"

							(aLapackMatrix productMatrixTransposeWithColumnVector: self castToColumn) transposed]
						ifFalse: 
							["Case (m,p)*(p,n)"

							| leftFlags rightFlags |
							leftFlags := self class flags bitAnd: PropertyMask.
							rightFlags := aLapackMatrix class flags bitAnd: PropertyMask.
							leftFlags <= rightFlags 
								ifTrue: 
									[self asUnpackedMatrix 
										productMatrixWithMatrix: aLapackMatrix asUnpackedMatrix]
								ifFalse: 
									[aLapackMatrix asUnpackedMatrix 
										productMatrixAtRightWithMatrix: self asUnpackedMatrix]]]]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
pseudoInverse
	"Compute pseudo inverse of self with default tolerance"

	^self pseudoInverseTolerance: self defaultTolerance! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
pseudoInverseTolerance: tol 
	"Let A = (U*S*V transposeConjugated)
	Then A pseudoInverse = (V*S reciprocal*U transposeConjugated)
	If some singular values are smaller than the tolerance they are not taken into account"

	| svd sigma |
	svd := self singularValueDecomposition.
	svd wantSomeSingularVector.
	sigma := svd s class diagonal: (svd s 
						collect: [:each | each <= tol ifTrue: [0] ifFalse: [each reciprocal]]).
	^svd v * sigma * svd ut! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
qrDecomposition
	"QR factorization"

	^LapackQRdecomposition decompose: self asGeneralMatrix! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
qrpDecomposition
	"QR factorization with column pivoting"

	^LapackQRPdecomposition decompose: self asGeneralMatrix! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
quotientFromLapackMatrix: aLapackMatrix 
	"More or less equivalent to :
		aLapackMatrix * self pseudoInverse"

	aLapackMatrix ncol = ncol 
		ifFalse: [^self error: 'matrix dimensions are not compatible'].
	^(self coercingButPropertyFromLapackMatrix: aLapackMatrix
				do: [:a :b | a rightDivideWithLapackMatrix: b])! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
rank
	"Compute rank of self with default tolerance"

	^self rankTolerance: self defaultTolerance! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
rankTolerance: tol 
	"Answer the number of linearly independant rows or columns of self.
	count non null singular values with a tolerance "

	^self singularValues count: [:each | each > tol ]! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
realPart
	"Fast implementation: copy every two reals"

	^self class isComplexMatrix 
		ifTrue: 
			[| res |
			((res := self class realMatrix nrow: nrow ncol: ncol) withArrayOffsetBy: 0) 
				copy: self arraySize
				elementsFrom: (self castToRealWithArrayOffsetBy: 0)
				sourceIncrement: 2
				destIncrement: 1.
			res]
		ifFalse: [self]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
reciprocal
	nrow = ncol ifFalse: [self error: 'should be square'].
	^self copy inPlaceSolve: (self class eye: nrow)! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
reduceGeneralityIfPossible
	^(self class isComplexMatrix and: [self imaginaryPart isZero]) 
		ifTrue: [self realPart]
		ifFalse: [self]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
rightDivideWithLapackMatrix: aLapackMatrix 
	"Answer the result of division
		self / aLapackMatrix
	NAIVE implementation.
	Should be coded more efficiently with direct DGESV or DGELSS calls ..."

	self isSquare 
		ifTrue: [self * aLapackMatrix reciprocal]
		ifFalse: 
			["self * aLapackMatrix pseudoInverse"

			| solver |
			solver := LapackLeastSquareProblem new 
						matrix: aLapackMatrix asGeneralMatrix transposed
						rhsMatrix: self asGeneralMatrix transposed.
			solver solution transposed]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
scaledByComplex: aComplex 
	"Answer a copy of self scaled.
	aComplex and self should agree on precision before sending this message."

	aComplex imaginary isZero ifTrue: [^self scaledByNumber: aComplex real].
	^self asComplexMatrix copy inPlaceScaledByComplex: aComplex! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
scaledByNumber: aNumber 
	"Answer a copy of self scaled.
	aNumber and self should agree on precision before sending this message."

	^self copy inPlaceScaledByNumber: aNumber! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
schurDecomposition
	^self isRealMatrix 
		ifTrue: [LapackRealSchurDecomposition decompose: self asGeneralMatrix]
		ifFalse: [LapackComplexSchurDecomposition decompose: self asGeneralMatrix]! !

!LapackMatrix methodsFor: 'initialize-release' stamp: 'nice 5/21/2006 02:24'!
setOffDiagonal: alpha diagonal: beta 
	
	[self lapackInterface 
		lasetWithuplo: self lapackInterface notTransposed
		m: nrow
		n: ncol
		alpha: alpha
		beta: beta
		a: self arrayPointer
		lda: nrow] 
			on: Error
			do: [:exc | exc return: (self naiveSetOffDiagonal: alpha diagonal: beta)]! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
singularValueDecomposition
	^LapackSVDecomposition decompose: self asGeneralMatrix! !

!LapackMatrix methodsFor: 'decomposition' stamp: ''!
singularValues
	^(self singularValueDecomposition)
		wantNoSingularVector;
		singularValues! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
solve: aMatrix 
	"Solve the linear equations self * X = aMatrix
	In other words, find X such that..."

	^aMatrix coercingButPropertyFromLapackMatrix: self
		do: [:a :b | a copy inPlaceSolve: b copy]! !

!LapackMatrix methodsFor: 'private' stamp: 'nice 5/17/2006 23:29'!
storeInSmalltalkSpace
	"This transfer is needed before saving an image..."
	
	self isInCSpace
		ifTrue: [array storeInSmalltalkSpace]! !

!LapackMatrix methodsFor: 'double dispatching' stamp: ''!
sumFromLapackMatrix: aLapackMatrix 
	(aLapackMatrix nrow = nrow and: [aLapackMatrix ncol = ncol]) 
		ifFalse: [self error: 'unconsistent matrix dimensions'].
	^self coercingFromLapackMatrix: aLapackMatrix
		do: [:a :b | a sumWithLapackMatrix: b]! !

!LapackMatrix methodsFor: 'arithmetic' stamp: ''!
sumWithLapackMatrix: aLapackMatrix 
	"at this point, matrices should have same class and compatible dimensions"

	| res |
	res := self copy.
	^res 
		fill: self arraySize
		elementsWithStride: 1
		withSelfPlusScalar: 1
		timesVector: aLapackMatrix
		stride: 1! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
swapColumn: j1 withColumn: j2 
	"Most matrices loose their properties when swapping columns"

	^(self become: self asGeneralMatrix) swapColumn: j1 withColumn: j2! !

!LapackMatrix methodsFor: 'accessing' stamp: ''!
swapRow: i1 withRow: i2 
	"Most matrices loose their properties when swapping rows"

	^(self become: self asGeneralMatrix) swapRow: i1 withRow: i2! !

!LapackMatrix methodsFor: 'converting' stamp: ''!
transposeConjugated
	^self class isComplexMatrix 
		ifTrue: [super transposeConjugated]
		ifFalse: [self transposed]! !

!LapackMatrix methodsFor: 'private' stamp: ''!
withArrayOffsetBy: aPositiveInteger 
	"Return a kind of shallow copy of self pointing on the same C underlying object, but with an offset.
	This is ugly like C code but maybe more efficient.
	This also has the side effect of hiding properties while storing elements
	(because property could be lost due to temporary disagreement when filling)"

	| newArray |
	newArray := self cArray withArrayOffsetBy: aPositiveInteger.
	^self class generalMatrix basicNew 
		setArray: newArray
		nrow: newArray size
		ncol: 1! !

!Object methodsFor: '*Smallapack-Matrix-testing' stamp: 'nice 5/20/2006 23:47'!
isSequenceable
	"answer true if i am a sequenceable collection"
	
	^false! !

!Object methodsFor: '*Smallapack-Matrix-testing' stamp: 'nice 5/20/2006 01:40'!
respondsToArithmetic
	"this is a VW compatibility message used by Smallapack"
	
	^false! !
LapackMatrix initialize!
LapackZTRMatrix initialize!
LapackZGEMatrix initialize!
LapackCGEMatrix initialize!
LapackDSYMatrix initialize!
LapackCDIMatrix initialize!
LapackZHEMatrix initialize!
LapackSTRMatrix initialize!
LapackCHEMatrix initialize!
LapackCTRMatrix initialize!
LapackDTRMatrix initialize!
LapackDDIMatrix initialize!
LapackZDIMatrix initialize!
LapackDGEMatrix initialize!
LapackSDIMatrix initialize!
LapackSGEMatrix initialize!
LapackSSYMatrix initialize!
